subroutine get_g (a, wr, transmode, T, g, n_mode)

    use thermodynamic
    implicit none
  

    double precision, dimension(n_mode), intent(in) :: a, wr
    logical, dimension(n_mode), intent(in) :: transmode
    double precision, intent(in) :: T
    double precision, dimension(n_mode,n_mode), intent(out) :: g                 
  
    integer :: mu, nu
    integer :: n_mode
    double precision, allocatable, dimension(:) :: da

    logical, parameter :: debug = .true.


    if (debug) then
      print *, "=== DEBUG GET_G ==="
      print *, "N_MODE:", n_mode
      call flush() 
    end if

    allocate(da(n_mode))

    call w_to_da(wr, T, da, n_mode)
  
    ! Calculate  the matrix g that will enter in the final equation
  
    do mu = 1, n_mode
      do nu = 1, n_mode
        if (transmode(mu) .or. transmode(nu)) then
          g(mu,nu) = 0.0d0
        else if (mu .eq. nu) then
          g(mu,nu) = da(mu) / wr(mu) / a(mu)**3.0d0
        else if ( mu .ne. nu .and. abs((wr(mu)-wr(nu))/wr(nu)) .lt. 0.00001d0) then
          !g(mu,nu) = 0.0d0
          g(mu,nu) = da(mu) / wr(mu) / a(mu)**3.0d0
        else
          g(mu,nu) = (a(mu)**2.0d0 - a(nu)**2.0d0) / (wr(mu)**2.0d0 - wr(nu)**2.0d0)  / &
                     ( a(nu)**2.0d0 * a(mu)**2.0d0 )
        end if
      end do
    end do
  
  end subroutine get_g
  

! This subroutine calculates the stochastic average of the third order
! force constants based on fu2 and lmat. The output force constants
! are given with three indexes that correspond to atom-cartesian coordinates.
!
! NOTE: there is a first addend that is not implemented at the moment
!       because it should be zero if the odd correction is calculated
!       at the atomic positions that minimize the gradient with respect
!       to Wyckoff positions. This non-implemented addend vanishes
!       if positions are fixed by symmetry.

subroutine get_v3 ( a, er, transmode, amass, ityp_sc, f, u, rho, log_err, v3, &
        nat_sc, n_mode, n_random, ntyp)

    use omp_lib
    use stochastic
    implicit none
  
    double precision, dimension(n_mode), intent(in) :: a
    double precision, dimension(nat_sc,n_mode,3), intent(in) :: er
    logical, dimension(n_mode), intent(in) :: transmode
    double precision, dimension(ntyp), intent(in) :: amass
    integer, dimension(nat_sc), intent(in) :: ityp_sc
    double precision, dimension(n_random,nat_sc,3), intent(in) :: f, u
    double precision, dimension(n_random), intent(in) :: rho
    character (len=10), intent(in) :: log_err
    double precision, dimension(n_mode,n_mode,n_mode), intent(out) :: v3
  
    integer :: nat_sc, n_mode, n_mode2, n_random, ntyp
  
    double precision, dimension(:,:), allocatable :: e, eprod
    double precision, dimension(:), allocatable :: fun
    double precision, dimension(:,:), allocatable :: ur, u2, f2 
     double precision :: av, av_err 
    
    integer :: i, j, mu, nu, alpha, beta
    integer :: ka, ja
    integer :: x, y, z, w, thread_num
  
    logical, parameter :: debug = .true.
    real :: t1, t2
  
    ! Get integers
  
    !nat_sc = size(er(:,1,1))
    !n_mode = 3*nat_sc
    n_mode2 = n_mode*n_mode
    !n_random = size(u(:,1,1))
  
    ! Allocate stuff
    if (debug) then
      print *, "=== V3 DEBUG ==="
      print *, "N_MODE:", n_mode
      print *, "N_RANDOM:", n_random
      print *, "NAT_SC:", nat_sc 

      print *, ""
      print *, "A displacemets:", a(:)
      print *, "Translations:", transmode(:)
      print *, "Weights:", rho(:)
      print *, "AMASS:", amass(:)
      call flush()
    end if
  
    

    allocate(e(n_mode,n_mode))
    allocate(eprod(n_mode,n_mode))
    allocate(ur(n_random,n_mode))
    allocate(u2(n_random,n_mode))
    allocate(f2(n_random,n_mode))
    allocate(fun(n_random))
  
    ! Calculate e polarization vectors with lengths and masses
  
    call get_emat (er, a, amass, ityp_sc, .false., transmode, e, n_mode, nat_sc, ntyp) 
  
    ! Get displacements in a rank two tensor
  
    ka = 0
  
    do i = 1, nat_sc
      do alpha = 1, 3
        ka = ka + 1
        u2(:,ka) = u(:,i,alpha)
        f2(:,ka) = f(:,i,alpha)
      end do
    end do  
  
    ! Calculate product between two e matrices
    ! eprod is the Upsilon matrix (see Raffaello's paper)
    call dgemm('T','N',n_mode,n_mode,n_mode,1.0d0,e,n_mode,&
               e,n_mode,0.0d0,eprod,n_mode)
  
    ! Rotate displacementes
    ! Here ur are Upsilon * u2
    do x = 1, n_mode
      ur(:,x) = 0.0d0
      do mu = 1, n_mode
        do y = 1, n_mode
          ur(:,x) = ur(:,x) + u2(:,y)*e(mu,x)*e(mu,y)
        end do
      end do
    end do
  
    ! Calculate the third order coefficients
  
    !thread_num = omp_get_max_threads ( )
  
    !$omp parallel SHARED ( v3, eprod, ur, f2, rho, n_mode, log_err ) PRIVATE ( x, y, z, fun, av, av_err )
    !$omp do
    do x = 1, n_mode
      do y = 1, n_mode
        do z = 1, n_mode 
          ! Here <eprod *f2> is eprod <f2> that correspond to subtract the average of the forces
          ! This term is important if the minimization is not performed on the average positions 
  !        fun(:) = - f2(:,x) * ur(:,y) * ur(:,z)
          fun(:) = ( eprod(y,z) - ur(:,y) * ur(:,z) ) * f2(:,x)
          call average_error_weight(fun,rho,log_err,av,av_err)
          v3(x,y,z) = av 
        end do
      end do
    end do
    !$omp end do
    !$omp end parallel
  
    deallocate(e,ur,u2,f2,fun)
  
  end subroutine get_v3
  

! By LORENZO MONACELLI
!
!
! Get the gradient of the system in the supercell using the Raffaello Bianco's equation
! EQ. A18b of PRB paper (2017) Second order structural....
!
! The equation is modified to exploit the noise reduction as:
!
!
! dF/dPhi = Lambda  Upsilon < u (f - f_scha) > 
!
! The Lambda matrix is the Hessian of the minimization Phi variable (Monacelli et al 2018 PRB)
! Upsilon matrix is the inverse of the covariance matrix Upsilon^{-1}_ab = <u_a u_b>
!
! An optional argumet can be passed, if true the Lambda matrix multiplication is not
! performed. In this way the gradient is automatically preconditioned.
  
subroutine get_gradient_supercell( n_random, natsc, n_modes, ntyp_sc, rho, u_disp, eforces, &
     wr_sc, epols_sc, trans, T, mass, ityp_sc, log_err, grad, grad_err, preconditioned)


  use stochastic
  
  implicit none
  
  integer, intent(in) :: n_random
  ! Number of random configurations
  integer, intent(in) :: natsc
  ! Number of atoms in the supercell
  integer, intent(in) :: n_modes
  ! Number of modes in the supercell (usually 3 * nat_sc)
  integer, intent(in) :: ntyp_sc
  ! Number of different type of atoms in the structure

  double precision, dimension(n_random), intent(in) :: rho
  ! The importance sampling weights of the configurations

  double precision, dimension(n_random, natsc, 3), intent(in) :: u_disp, eforces
  !
  ! The displacement vectors and forces - sscha forces for each configuration.
  ! Displacements are required in bohr, while forces in Ha/bohr
  ! Most importantly, forces and wr unit of measurement must coincide:
  ! If wr is in Ha and u_disp in bohr then forces must be Ha/bohr
  ! if wr is in Ry and u_disp in angstrom then forces must be in Ry/angstrom
  !
  
  double precision, dimension(n_modes), intent(in) :: wr_sc
  double precision, dimension(3 * natsc, n_modes), intent(in) :: epols_sc
  !
  ! Frequencies (in Ha or look above) and polarization vectors for each mode
  ! Polarization vectors are contracted so that the x coord of the i-th atom
  ! of the j-th vector is accessed by epols_sc(x + 3*(i-1), j)
  ! this allows an easy wrapping to the subroutine with python code.
  !
  
  logical, dimension(n_modes), intent(in) :: trans
  ! This is a vector that is True if the mode is a translation, False otherwise
  ! It is needed to generate the Upsilon matrix (as it has a diverging eigenvalue for w->0)

  double precision, intent(in) :: T
  ! Temperature of the system (also this is used to compute the upsilon matrix)

  double precision, dimension(ntyp_sc),  intent(in) :: mass
  ! Mass of the atoms
  ! The unit of measure must be in masses of the electron. (the mass saved in the QE dynamical matrix file
  ! must be multiplied by 2 to match this unit).

  integer, dimension(natsc), intent(in) :: ityp_sc
  ! Type of the atoms in the supercell
  
  character(len=10), intent(in) :: log_err
  ! A flag used to chose the kind of average to be performed 

  double precision, dimension(3*natsc, 3*natsc), intent(out) :: grad, grad_err
  !
  ! The output gradient and its error in real space.
  ! Note that it needs to be symmetrized.
  !
  logical, optional, intent(in) :: preconditioned
  ! If true (default) the gradient is computed without the Lambda matrix mutliplication,
  ! That is as if it was already preconditioned

  
  ! ---------------------------------- END OF INPUT DEFINITION ------------------------------------
  integer i, j, alpha, beta, ical, jcal
  double precision, dimension(3*natsc, 3*natsc) :: uf_mat, err_uf_mat, ups_mat, tmp
  double precision, dimension(3*natsc) :: v_aux1, v_aux2
  double precision t1, t2
  logical precond
  logical, parameter :: print_input = .false.


  ! Setup the default value of the preconditioned variable
  if (present(preconditioned)) then
     precond = preconditioned
  else
     precond = .true.
  end if


  ! DEBUG INPUT
  if (print_input) then
     print *, "GET_GRADIENT_SUPERCELL INPUT VALUES:"
     print *, "NRAND:", n_random
     print *, "NAT_SC:", natsc
     print *, "N_MODES:", n_modes
     print *, "NTYP_SC:", ntyp_sc
     print *, "RHO:", rho(:)
     print *, "W:", wr_sc(:)
     print *, "TRANS:", trans(:)
     print *, "T:", T
     print *, "MASS:", mass
     print *, "ITYP_SC:", ityp_sc
     print *, "LOG_ERR:", log_err

     print *, ""
     print *, "POL VECTORS:"
     do i = 1, 3*natsc
        print "(A10, I8, A10, 1000E13.4)", "MODE", i, "VECTOR", epols_sc(:, i) 
    end do
    
    print *, ""
    print *, "INPUT U and F"
    do i = 1, n_random
        ! Create the auxiliary vector
        do j = 1, natsc
            do alpha = 1, 3
                v_aux1(alpha + 3* (j-1)) = eforces(i, j, alpha)
                v_aux2(alpha + 3*(j-1)) = u_disp(i, j, alpha)
            end do
        end do
        
        print "(A10, I8, A10, 1000E13.4)", "CONF", i, "FORCE", v_aux1(:)
        print "(A10, I8, A10, 1000E13.4)", "CONF", i, "DISP", v_aux2(:)
    end do
    
    call flush()
  end if
  
  ! Compute the <uf> matrix in the supercell
  uf_mat = 0.0d0
  err_uf_mat = 0.0d0

  ! print *, "DISP FORCES:"
  ! do i = 1, size(u_disp(:, 1,1))
  !    print *, "CONFIG", i, "RHO:", rho(i)
  !    do j = 1, natsc(
  !       print *, "U:", u_disp(i,j,:), "F:", eforces(i,j,:)
  !    end do
  ! end do
  
  
  call cpu_time(t1)
  !$OMP PARALLEL DO COLLAPSE(4) PRIVATE(ical, jcal)
  do alpha = 1, 3
     do beta = 1, 3
        do i = 1, natsc
           do j = 1, natsc
              ical = alpha + (i-1)*3
              jcal = beta + (j-1)*3
              call average_error_weight(u_disp(:, i, alpha) * eforces(:,  j, beta), &
                   rho, log_err, uf_mat(ical, jcal), err_uf_mat(ical, jcal))
              !print *, "Terra di mezzo:", ical, jcal, "UF:", uf_mat(ical, jcal), &
              !     sum(u_disp(:, i, alpha) * eforces(:, j, beta)) / sum(rho)
           end do
        end do
     end do
  end do
  !$OMP END PARALLEL DO

  ! Impose the hermitianity
  ! do ical = 1, 3*natsc
  !    do jcal = ical, 3*natsc
  !       uf_mat(ical, jcal) = 0.5d0 * (uf_mat(ical, jcal) + uf_mat(jcal, ical))
  !       err_uf_mat(ical, jcal) = 0.5d0 *dsqrt(err_uf_mat(ical, jcal)**2 + err_uf_mat(ical, jcal)**2)
  !       if (ical /= jcal) then
  !          uf_mat(jcal, ical) = uf_mat(ical, jcal)
  !          err_uf_mat(jcal, ical) = err_uf_mat(ical, jcal)
  !       end if
  !    end do
  ! end do
  call cpu_time(t2)
  
  print *, " Time to compute <uf> in real space: ", t2 - t1
  call flush()

  ! Compute the upsilon matrix in the supercell
  call cpu_time(t1)
  call get_upsilon_matrix(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, mass, ityp_sc, T, ups_mat)
  call cpu_time(t2)
  !print *, "Time to compute the upsilon matrix:", t2 - t1

  ! Perform the matrix multiplication
  ! Grad = - Upsilon . <u(f - fscha)>
  ! Note the '-' sign is applied only in the gradient not in the error

  if (print_input) then
     print *, "======== UF MAT ========="
     do ical = 1, 3*natsc
        print "(10000E16.5)", uf_mat(:, ical)
     end do
     
     print *, ""
     print *, "========== UPS MAT ========"
     do ical = 1, 3*natsc
        print "(10000E16.5)", ups_mat(:, ical)
     end do
     print *, ""
  end if
     
  call cpu_time(t1)
  call dgemm("N", "N", 3*natsc, 3*natsc, 3*natsc, 1.0d0, ups_mat, 3*natsc,  uf_mat, 3*natsc, 0.0d0, grad, 3*natsc)
  call dgemm("N", "N", 3*natsc, 3*natsc, 3*natsc, 1.0d0, ups_mat, 3*natsc,  err_uf_mat, 3*natsc, 0.0d0, grad_err, 3*natsc)
  call cpu_time(t2)
  print *, " get_gradient_supercell : Elapsed time to perform the multiplication", t2 - t1
  call flush()
  ! Symmetrize the gradient
  ! In fact the product of symmetric matrices is not symmetric!!!!
  do ical = 1, 3*natsc-1
     do jcal = ical + 1, 3*natsc
        grad(ical, jcal) = 0.5d0 * (grad(ical, jcal) + grad(jcal, ical))
        grad(jcal,ical) = grad(ical, jcal)
     end do
  end do

  ! ! Print the gradient
  ! print *, "======= GRADIENT NOW ======="
  ! do ical = 1, 3*natsc
  !    print "(1000E16.5)", grad(:, ical)
  ! end do
  ! call flush()
  
  ! Perform the inverse preconditioning if required:
  if (.not. precond) then
     print *, "Applying the dPsi/dPhi tensor to the gradient [This may require some time for system with more than 50 atoms]"
     print *, "If it takes too long, turn on preconditioning."
     call flush()
     call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
          mass, ityp_sc, T, grad, tmp, .false.)
     ! The lambda matrix is negative defined so multiply it by -1
     grad = -tmp
     !print *, "Setting the error..."
     !call flush()
     call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
          mass, ityp_sc, T, grad_err, tmp, .false.)
     grad_err = tmp
  end if
  !print *, "Exiting..."
  !call flush()
  
end subroutine get_gradient_supercell


!
! The following subroutine uses a different algorithm
! It first computes Yu vector and then averages
! < (Yu) f>
!
! In this way the gradient is computed correctly with the correct stochastic error
!

subroutine get_gradient_supercell_new( n_random, natsc, n_modes, ntyp_sc, rho, u_disp, eforces, &
   wr_sc, epols_sc, trans, T, mass, ityp_sc, log_err, grad, grad_err)


use stochastic

implicit none

integer, intent(in) :: n_random
! Number of random configurations
integer, intent(in) :: natsc
! Number of atoms in the supercell
integer, intent(in) :: n_modes
! Number of modes in the supercell (usually 3 * nat_sc)
integer, intent(in) :: ntyp_sc
! Number of different type of atoms in the structure

double precision, dimension(n_random), intent(in) :: rho
! The importance sampling weights of the configurations

double precision, dimension(n_random, natsc, 3), intent(in) :: u_disp, eforces
!
! The displacement vectors and forces - sscha forces for each configuration.
! Displacements are required in bohr, while forces in Ha/bohr
! Most importantly, forces and wr unit of measurement must coincide:
! If wr is in Ha and u_disp in bohr then forces must be Ha/bohr
! if wr is in Ry and u_disp in angstrom then forces must be in Ry/angstrom
!

double precision, dimension(n_modes), intent(in) :: wr_sc
double precision, dimension(3 * natsc, n_modes), intent(in) :: epols_sc
!
! Frequencies (in Ha or look above) and polarization vectors for each mode
! Polarization vectors are contracted so that the x coord of the i-th atom
! of the j-th vector is accessed by epols_sc(x + 3*(i-1), j)
! this allows an easy wrapping to the subroutine with python code.
!

logical, dimension(n_modes), intent(in) :: trans
! This is a vector that is True if the mode is a translation, False otherwise
! It is needed to generate the Upsilon matrix (as it has a diverging eigenvalue for w->0)

double precision, intent(in) :: T
! Temperature of the system (also this is used to compute the upsilon matrix)

double precision, dimension(ntyp_sc),  intent(in) :: mass
! Mass of the atoms
! The unit of measure must be in masses of the electron. (the mass saved in the QE dynamical matrix file
! must be multiplied by 2 to match this unit).

integer, dimension(natsc), intent(in) :: ityp_sc
! Type of the atoms in the supercell

character(len=10), intent(in) :: log_err
! A flag used to chose the kind of average to be performed 

double precision, dimension(3*natsc, 3*natsc), intent(out) :: grad, grad_err
!
! The output gradient and its error in real space.
! Note that it needs to be symmetrized.
!


! ---------------------------------- END OF INPUT DEFINITION ------------------------------------
integer i, j, alpha, beta, ical, jcal, i_r
double precision, dimension(3*natsc, 3*natsc) :: uf_mat, err_uf_mat, ups_mat, tmp
double precision, dimension(n_random, natsc, 3) :: v_disp
double precision, dimension(3*natsc) :: v_aux1, v_aux2
double precision t1, t2
logical precond
logical, parameter :: print_input = .false.


! This method works only with the preconditioning
precond = .true.



! DEBUG INPUT
if (print_input) then
   print *, "GET_GRADIENT_SUPERCELL INPUT VALUES:"
   print *, "NRAND:", n_random
   print *, "NAT_SC:", natsc
   print *, "N_MODES:", n_modes
   print *, "NTYP_SC:", ntyp_sc
   print *, "RHO:", rho(:)
   print *, "W:", wr_sc(:)
   print *, "TRANS:", trans(:)
   print *, "T:", T
   print *, "MASS:", mass
   print *, "ITYP_SC:", ityp_sc
   print *, "LOG_ERR:", log_err

   print *, ""
   print *, "POL VECTORS:"
   do i = 1, 3*natsc
      print "(A10, I8, A10, 1000E13.4)", "MODE", i, "VECTOR", epols_sc(:, i) 
  end do
  
  print *, ""
  print *, "INPUT U and F"
  do i = 1, n_random
      ! Create the auxiliary vector
      do j = 1, natsc
          do alpha = 1, 3
              v_aux1(alpha + 3* (j-1)) = eforces(i, j, alpha)
              v_aux2(alpha + 3*(j-1)) = u_disp(i, j, alpha)
          end do
      end do
      
      print "(A10, I8, A10, 1000E13.4)", "CONF", i, "FORCE", v_aux1(:)
      print "(A10, I8, A10, 1000E13.4)", "CONF", i, "DISP", v_aux2(:)
  end do
  
  call flush()
end if

! Compute the <uf> matrix in the supercell
uf_mat = 0.0d0
err_uf_mat = 0.0d0

! print *, "DISP FORCES:"
! do i = 1, size(u_disp(:, 1,1))
!    print *, "CONFIG", i, "RHO:", rho(i)
!    do j = 1, natsc(
!       print *, "U:", u_disp(i,j,:), "F:", eforces(i,j,:)
!    end do
! end do

! Compute the upsilon matrix in the supercell
call cpu_time(t1)
call get_upsilon_matrix(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, mass, ityp_sc, T, ups_mat)
call cpu_time(t2)
!print *, "Time to compute the upsilon matrix:", t2 - t1


!$OMP PARALLEL DO PRIVATE(ical, jcal)
do i_r = 1, n_random
   do alpha = 1, 3
      do i = 1, natsc
         ical = alpha + (i-1)*3
         v_disp(i_r, i, alpha) = 0.0d0

         ! Sum up
         do beta = 1, 3
            do j = 1, natsc
               jcal = beta + (j-1)*3
               v_disp(i_r, i, alpha) = v_disp(i_r, i, alpha) + u_disp(i_r, j, beta) * ups_mat(jcal, ical)
            enddo
         enddo
      enddo
   enddo
enddo
!$OMP END PARALLEL DO


call cpu_time(t1)
!$OMP PARALLEL DO COLLAPSE(4) PRIVATE(ical, jcal)
do alpha = 1, 3
   do beta = 1, 3
      do i = 1, natsc
         do j = 1, natsc
            ical = alpha + (i-1)*3
            jcal = beta + (j-1)*3
            call average_error_weight(v_disp(:, i, alpha) * eforces(:,  j, beta), &
                 rho, log_err, grad(ical, jcal), grad_err(ical, jcal))
            !print *, "Terra di mezzo:", ical, jcal, "UF:", uf_mat(ical, jcal), &
            !     sum(u_disp(:, i, alpha) * eforces(:, j, beta)) / sum(rho)
         end do
      end do
   end do
end do
!$OMP END PARALLEL DO

! Impose the hermitianity
! do ical = 1, 3*natsc
!    do jcal = ical, 3*natsc
!       uf_mat(ical, jcal) = 0.5d0 * (uf_mat(ical, jcal) + uf_mat(jcal, ical))
!       err_uf_mat(ical, jcal) = 0.5d0 *dsqrt(err_uf_mat(ical, jcal)**2 + err_uf_mat(ical, jcal)**2)
!       if (ical /= jcal) then
!          uf_mat(jcal, ical) = uf_mat(ical, jcal)
!          err_uf_mat(jcal, ical) = err_uf_mat(ical, jcal)
!       end if
!    end do
! end do
call cpu_time(t2)

!print *, " Time to compute <uf> in real space: ", t2 - t1
!call flush()

! Perform the matrix multiplication
! Grad = - Upsilon . <u(f - fscha)>
! Note the '-' sign is applied only in the gradient not in the error

if (print_input) then
   print *, "======== UF MAT ========="
   do ical = 1, 3*natsc
      print "(10000E16.5)", uf_mat(:, ical)
   end do
   
   print *, ""
   print *, "========== UPS MAT ========"
   do ical = 1, 3*natsc
      print "(10000E16.5)", ups_mat(:, ical)
   end do
   print *, ""
end if
   
!call cpu_time(t1)
!call dgemm("N", "N", 3*natsc, 3*natsc, 3*natsc, 1.0d0, ups_mat, 3*natsc,  uf_mat, 3*natsc, 0.0d0, grad, 3*natsc)
!call dgemm("N", "N", 3*natsc, 3*natsc, 3*natsc, 1.0d0, ups_mat, 3*natsc,  err_uf_mat, 3*natsc, 0.0d0, grad_err, 3*natsc)
!call cpu_time(t2)
!print *, " get_gradient_supercell : Elapsed time to perform the multiplication", t2 - t1
!call flush()

! Symmetrize the gradient
! In fact the product of symmetric matrices is not symmetric!!!!
do ical = 1, 3*natsc-1
   do jcal = ical + 1, 3*natsc
      grad(ical, jcal) = 0.5d0 * (grad(ical, jcal) + grad(jcal, ical))
      grad(jcal,ical) = grad(ical, jcal)
   end do
end do

! ! Print the gradient
! print *, "======= GRADIENT NOW ======="
! do ical = 1, 3*natsc
!    print "(1000E16.5)", grad(:, ical)
! end do
! call flush()

! Perform the inverse preconditioning if required:
if (.not. precond) then
   print *, "Applying the dPsi/dPhi tensor to the gradient [This may require some time for system with more than 50 atoms]"
   print *, "If it takes too long, turn on preconditioning."
   call flush()
   call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
        mass, ityp_sc, T, grad, tmp, .false.)
   ! The lambda matrix is negative defined so multiply it by -1
   grad = -tmp
   !print *, "Setting the error..."
   !call flush()
   call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
        mass, ityp_sc, T, grad_err, tmp, .false.)
   grad_err = tmp
end if
!print *, "Exiting..."
!call flush()

end subroutine get_gradient_supercell_new

! This subroutine calculates the L mat needed to get the average of the 
! third order derivatives. It is formed by four polarization vectors 
! times the mass^1/2 divided by the normal length.

subroutine get_odd_straight ( a, wr, er, transmode, amass, ityp_sc, T, v3, phi_sc_odd, &
    n_mode, nat_sc, ntyp)

  implicit none

  double precision, dimension(n_mode), intent(in) :: a, wr
  double precision, dimension(nat_sc,n_mode,3), intent(in) :: er
  logical, dimension(n_mode), intent(in) :: transmode
  double precision, dimension(ntyp), intent(in) :: amass
  integer, dimension(nat_sc), intent(in) :: ityp_sc
  double precision, intent(in) :: T
  double precision, dimension(n_mode,n_mode,n_mode), intent(in) :: v3
  double precision, dimension(n_mode, n_mode), intent(out) :: phi_sc_odd

  integer :: nat_sc, n_mode, nl, ns, ntyp
  double precision, dimension(:,:), allocatable :: l, g, phi_aux, v1, v2, v32, maux
  double precision :: lsum 
  double precision, dimension(:), allocatable :: laux1, lres1, veclong
  double precision, dimension(:), allocatable :: laux2, lres2
 
  integer :: mu, nu, alpha
  integer :: ka, ja
  integer :: i, j, x, y, z, w

  real :: t1, t2
  logical, parameter :: debug = .false.

  ! Get integers

  !nat_sc = size(er(:,1,1))
  !n_mode = 3*nat_sc

  ns = n_mode
  nl = n_mode*n_mode

  ! Allocate stuff
  if (debug) then
    print *, "=== DEBUG ODD STRAIGHT ==="
    print *, "N_MODE:", n_mode
    print *, "NTYP:", ntyp 
    print *, "NAT_SC:", nat_sc
    call flush()
  end if

  allocate(l(n_mode,n_mode))
  allocate(g(n_mode,n_mode))
  !allocate(phi_aux(n_mode,n_mode))
  allocate(v1(n_mode,n_mode*n_mode))
  allocate(v2(n_mode,n_mode*n_mode))
  allocate(v32(n_mode,n_mode*n_mode))
  allocate(laux1(n_mode))
  allocate(lres1(n_mode))
  allocate(laux2(n_mode))
  allocate(lres2(n_mode))
  allocate(maux(n_mode,n_mode))
  allocate(veclong(nl))

  ! Allocate stuff
  if (debug) then
    print *, "=== DEBUG ODD STRAIGHT ==="
    print *, "AFTER ALLOCATION"
    call flush()
  end if


  ! Define the polarization vectors as a 3n x 3n matrix (n = nat_sc).
  ! The square root of the mass is also included in the new matrix
  ! and also the normal length 

  call get_emat ( er, a, amass, ityp_sc, .true., transmode, l, n_mode, nat_sc, ntyp)

  ! Calculate  the matrix g that will enter in the final equation

  call get_g (a, wr, transmode, T, g, n_mode)

  ! Allocate stuff
  if (debug) then
    print *, "=== DEBUG ODD STRAIGHT ==="
    print *, "AFTER G"
    print *, "G [nmode, nmode]:"
    do x = 1, n_mode
      print *, G(:, x)
    enddo
    print *, ""
    print *, "L [nmode, nmode]:"
    do x = 1, n_mode
      print *, l(:, x)
    enddo
    print *, ""
    call flush()
  end if
 
  ! Write third order force constants as rank 2

  ka = 0
   
  do x = 1, n_mode
    do y = 1, n_mode
      ka = ka + 1
      v32(:,ka) = v3(:,x,y)
    end do
  end do

  ! Calculate the auxiliary matrices

  ja = 0

!  do mu = 1, n_mode
!    do nu = 1, n_mode
!      veclong = 0.0d0
!      ka = 0
!      do x = 1, n_mode    
!        do y = 1, n_mode
!          ka = ka + 1
!          veclong(ka) = l(mu,x)*l(nu,y) 
!        end do
!      end do    
!      call dgemv ('N',ns,nl,1.0d0,v32,ns,veclong,1,0.0d0,lres1,1) 
!      ja = ja + 1
!      v2(:,ja) = lres1(:) * g(mu,nu)
!      v1(:,ja) = lres1(:) * 0.5d0
!    end do
!  end do

  do i = 1, n_mode
    maux(:,:) = v3(i,:,:)
    ja = 0 
    do mu = 1, n_mode 
      laux1 = l(mu,:)
      do nu = 1, n_mode         
        laux2 = l(nu,:)
        call dgemv ('N',ns,ns,1.0d0,maux,ns,laux1,1,0.0d0,lres1,1)
        ja = ja + 1
!        call dgemv ('T',ns,1,1.0d0,lres1,ns,laux2,1,0.0d0,lsum,1)
        v1(i,ja) = dot_product(lres1,laux2) 
        v2(i,ja) = v1(i,ja) * g(mu,nu)
        v1(i,ja) = v1(i,ja) * 0.5d0
!        v2(i,ja) = lsum * g(mu,nu)
!        v1(i,ja) = lsum * 0.5d0
      end do
    end do
  end do

!  do i = 1, n_mode
!    ka = 0
!    do mu = 1, n_mode
!      do nu = 1, n_mode
!        ka = ka +1
!        v1(i,ka) = 0.0d0
!        v2(i,ka) = 0.0d0
!        do x = 1, n_mode
!          do y = 1, n_mode
!            v1(i,ka) = v1(i,ka) + v3(i,x,y)*l(nu,x)*l(mu,y)*0.5d0
!            v2(i,ka) = v2(i,ka) + v3(i,x,y)*l(nu,x)*l(mu,y)*g(mu,nu)
!          end do
!        end do
!      end do
!    end do
!  end do
!
!  ! Make matrix product to get the odd correction
!
!  ns = n_mode
!  nl = n_mode*n_mode

  call dgemm('N','T',ns,ns,nl,1.0d0,v1,ns,v2,ns,0.0d0,phi_sc_odd,ns)

  ! Write the odd correction with four indexes

  !call twotofour_real (phi_aux,phi_sc_odd)

  if (debug) then
    print *, "=== AFTER ODD STRAIGHT ==="
    print *, "V1:"
    do x = 1, n_mode
      print *, v1(x, :)
    enddo

    print *, ""
    print *, "V2:"
    do x = 1, n_mode
      print *, v2(x, :)
    enddo 
    print *, ""

    print *, "ODD CORRECTION:"
    do x = 1, n_mode
      print *, phi_sc_odd(:, x)
    enddo
  endif

  ! Deallocate stuff

  deallocate(l,g,v1,v2,v32)

end subroutine get_odd_straight 

module anharmonic
  use stochastic
  use thermodynamic
  
contains

  ! This subroutines computes df/da the first part of the
  ! Gradient for the SCHA code.
  !
  ! w <= Frequencies [Ha]
  ! w_harmonic <= Used only if stat-method = "stat_harmon"
  ! T <= Temperature [K]
  ! e <= Pol vectors (i,j) i is the coordinate, j the mode
  ! forces <= [Ha / bohr] (a,b,c) a is the random conf, b the atom, c the coord.
  ! q <= the q vector [bohr] (a,b) a is the config, b is the mode
  ! type_atoms <= same atoms have the same integer
  ! mass <= Mass (in Ha)
  ! stat_method <= string use "stat_normal"
  ! df_da => Result [Ha / bohr]
  subroutine get_df_da_nonav (w,w_harmonic,T,e,forces,q,mass,&
       stat_method,df_da, l, n, m)
 
    implicit none
    
    double precision, dimension(n), intent(in) :: w
    double precision, dimension(n), intent(in) :: w_harmonic
    double precision, intent(in) :: T
    double precision, dimension(3*m,n), intent(in) :: e
    double precision, dimension(l,m,3), intent(in) :: forces
    double precision, dimension(l,n), intent(in) :: q
    !double precision, dimension(n), intent(in) :: a
    double precision, dimension(m), intent(in) :: mass
    character (len=11), intent(in) :: stat_method
    double precision, dimension(l,n), intent(out) :: df_da

    integer, intent(in) ::  l, n, m
    
    integer :: i1, i2, i3, j, natoms, nrandom, nmodes, i3n
    double precision, dimension(:,:), allocatable :: f
    double precision, dimension(:,:), allocatable :: mat_a, mat_b, mat_c
    double precision, dimension(:,:), allocatable :: e_diag
    double precision, dimension(n) :: a, da_dw
    double precision, dimension(3*m) :: u_sqrtm 

    
    natoms  = m
    nrandom = l
    nmodes  = n
    
    allocate(mat_a(nmodes, 3 * natoms))
    allocate(mat_b(3 * natoms, nmodes))
    allocate(mat_c(nmodes,nmodes))
    allocate(f(nmodes,nrandom))
    allocate(e_diag(3*natoms, nmodes))

    ! Get a and da_dw
    call w_to_a(w, T, a, n)
    call w_to_da(w, T, da_dw, n)
    
    
!    ! Print all the info about the input parameters [DEBUG]
!    print *, ""
!    print *, "======== dF / dA INPUT VARIABLES ========="
!    print *, "w = ", w
!    print *, "w_harm = ", w_harmonic
!    print *, "a = ", a
!    print *, "T = ", T
!    print *, "Type atoms:", type_atoms
!    print *, "Mass = ", mass
!    print *, "Stat = ", stat_method
!    print *, "Pol vectors:"
!    do i1 = 1, nmodes
!        print "(I4, A3, 1000D16.8)", i1, ")", e(:, i1)
!    end do
!    print *, "Forces:"
!    do i1 = 1, nrandom
!        do i2 = 1, natoms
!            print "(A10, I4, A10, I4, A3, 3D16.8)", "Conf", i1, "Atom", i2, "=", forces(i1, i2, :)
!        end do
!    end do
!    print *, "q vectors:"
!    do i1 = 1, nrandom
!        print "(I4, A3, 1000D16.8)", i1, ")", q(i1, :)
!    end do
!    
    
    ! Create the auxiliar polarization vectors dividing by the
    ! the polarization vectors


    i3n = 0
    do i1 = 1, natoms
       do i3 = 1, 3
          i3n = i3n +1
          e_diag(i3n,:) = e(i3n,:) / dsqrt(mass(i1))
       end do
    end do

!    ! Print the quantity that should not change
!    print *, "Pol dot q:"
!    do i1 = 1, nrandom
!        u_sqrtm = 0.0d0
!        do i2 = 1, nmodes
!            u_sqrtm = u_sqrtm + e_diag(:, i2)* q(i1, i2)
!        end do
!        print "(A10, I4, A3, 1000D16.8)", "Conf", i1, "=", u_sqrtm
!    end do
!    print *, "====== dF / dA END INPUT VARIABLES ======="
!    print *, ""
    ! Create mat_a matrix

    do i1 = 1, nmodes
       ! if (.not. mu_relevant(i1)) then
       !    mat_a(i1,:) = 0.0d0 
       !    cycle
       ! end if
       i3n = 0
       do i2 = 1, natoms
          do i3 = 1, 3
             i3n = i3n + 1
             mat_a(i1,i3n) = e_diag(i3n, i1) / a(i1)
          end do
       end do
    end do

    ! Loop on the nmodes to build the function that we will
    ! use for the statistics.

    do j = 1, nrandom

       ! Build the mat_b matrix

       do i1 = 1, nmodes
          i3n = 0
          do i2 = 1, natoms
             do i3 = 1, 3
                i3n = i3n + 1
                mat_b(i3n,i1) = -forces(j,i2,i3)*q(j,i1)
             end do
          end do
       end do

       ! Call lapack subroutine to calculate matrix product

       call dgemm('N','N',nmodes,nmodes,3*natoms,1.0d0,mat_a,nmodes,&
            mat_b,3*natoms,0.0d0,mat_c,nmodes)
            
       ! Print the new matrix
!       
!       print *, ""
!       print *, "MAT A  Conf", j
!       do i1 = 1, 3*natoms
!           print *, mat_a(:, i1)
!       end do 
!       print *, "MAT B  Conf", j
!       do i1 = 1, nmodes
!           print *, mat_b(:, i1)
!       end do 
!       print *, "MAT C  Conf", j
!       do i1 = 1, nmodes
!           print *, mat_c(:, i1)
!       end do 

       ! Create the gradient according to the different possible statistics

       do i1 = 1, nmodes
          f(i1,j) = mat_c(i1,i1)
       end do

       ! Include in the gradients the analytical part

       do i1 = 1, nmodes
          if (stat_method .eq. 'stat_normal') then
             df_da(j,i1) = f(i1,j) + dW_f0_u0(w(i1),T) / da_dw(i1)
          else if (stat_method .eq. 'stat_harmon') then
             df_da(j,i1) = f(i1,j) + dW_f0_u0(w(i1),T) / da_dw(i1) &
                  + w_harmonic(i1)**2.0d0 * a(i1)
          else if (stat_method .eq. 'stat_schapp') then
             df_da(j,i1) = f(i1,j) !+ dW_f0_u0(w(i1),T) / w_to_da(w(i1),1.0d0,T) &
             !+ w(i1)**2.0d0 * a(i1)
          else
             stop "ERROR, STAT_METHOD NOT VALID"
          end if
       end do
    end do

    deallocate(mat_a)
    deallocate(mat_b)
    deallocate(mat_c)
    deallocate(f)
    deallocate(e_diag)

  end subroutine get_df_da_nonav
  
  
  ! The following subroutine computes the last derivatives
  ! That are 
  
  subroutine get_da_dcr_and_de_dcr (wr, er, T, mass, x_i, y_i, da_dcr, de_dcr, n, m ) 

    implicit none

    double precision, dimension(n), intent(in) :: wr
    double precision, dimension(3*m,n), intent(in) :: er
    double precision, intent(in) :: T
    double precision, dimension(m), intent(in) :: mass
    integer, intent(in) :: x_i, y_i
    double precision, dimension(n), intent(out) :: da_dcr
    double precision, dimension(3*m, n), intent(out) :: de_dcr
    
    ! Optional integer
    integer, intent(in) :: n, m

    integer :: nmodes, natsc
    integer :: i, mu, nu, alpha, atm_x, atm_y
    double precision, dimension(:,:), allocatable :: g, gamma_mu_nu
    double precision, dimension(n) :: da_dw

    natsc  = m
    nmodes = n
    
    atm_x = (x_i - 1) / 3 + 1
    atm_y = (y_i -1 ) / 3 + 1

    allocate(g(nmodes,nmodes))
    allocate(gamma_mu_nu(nmodes, nmodes))
    
    ! Prepare gamma_mu_nu
    do mu = 1, nmodes
        do nu = 1, nmodes
            gamma_mu_nu(mu, nu) = er(x_i, mu) * er(y_i, nu) /&
                dsqrt(mass(atm_x) * mass(atm_y))
        end do
    end do

    ! Take the derivative of w_to_da
    call w_to_da(wr, T, da_dw, nmodes)

    do mu = 1, nmodes
        da_dcr(mu) = 0.5d0 * da_dw(mu) * gamma_mu_nu(mu,mu) / wr(mu)
    end do

    ! Prepare matrices for product

    do nu = 1, nmodes
       do mu = 1, nmodes
          if (abs((wr(mu)-wr(nu))/wr(nu)) .lt. 0.00001d0) then
             g(mu,nu) = 0.0d0
          else
             g(mu,nu) = gamma_mu_nu(mu,nu) / (wr(nu)**2 - wr(mu)**2) 
          end if
       end do
    end do

    ! Make matrix product

    call dgemm('N','N',nmodes,nmodes,nmodes,1.0d0,er, &
         nmodes,g,nmodes,0.0d0,de_dcr,nmodes)
    deallocate(g)

  end subroutine get_da_dcr_and_de_dcr
  
  
  ! This subroutine gets the derivative of the Free energy with respect
  ! to the minimum number of coefficients that decompose the dynamical 
  ! matrices. In this case the statistics are performed here. Thus,
  ! the error of the gradoient is also calculated in this subroutine.
  ! In this new version the value of dF/de is calculated in this 
  ! subroutine. This is done to solve memory problems. 
  
  subroutine get_df_dcoeff_av_new (df, da, forces, q, mass, dedc, rho, &
       minim_polvec, log_err, dfdc, delta_dfdc, r, s, t)

    implicit none

    integer, intent(in) :: r,s,t
    double precision, dimension(r,s), intent(in) :: df, q
    double precision, dimension(s), intent(in) :: da
    double precision, dimension(t), intent(in) ::  mass
    double precision, dimension(r,t,3), intent(in) :: forces
    double precision, dimension(3*t,s), intent(in) :: dedc
    double precision, dimension(r), intent(in) :: rho
    logical, intent(in) :: minim_polvec
    !  character (len=11), intent(in) :: stat_method
    character (len=10), intent(in) :: log_err
    double precision, intent(out) :: dfdc, delta_dfdc
    

    double precision, dimension(:), allocatable :: f
    integer :: nat, nmodes, nrandom
    double precision :: aux
    integer :: i, alpha, mu, n, i3n
    double precision :: sqrtm1mass(t)


    sqrtm1mass = 1.d0/DSQRT(mass)
    nmodes = s
    nat = t
    nrandom = r
    
    allocate(f(nrandom))

    ! Compute df/da * da/dcr
    f = 0.d0
    do mu = 1,nmodes
       do n = 1, nrandom
          f(n) = f(n)+df(n,mu)*da(mu)
       end do
    enddo


    ! Compute df/de * de/dcr
    if (minim_polvec) then
      !
      do mu = 1, nmodes
        i3n = 1
        do i = 1, nat
            do alpha = 1, 3
               aux =  sqrtm1mass(i) * dedc(i3n,mu)  
               i3n = i3n + 1
               !do n = 1, nrandom
               FORALL(n=1:nrandom) 
                  f(n) = f(n) - aux * forces(n,i,alpha) * q(n,mu)
               END FORALL
            end do 
        end do
      end do
      !
    endif

    ! Calculate the statistics
    call average_error_weight(f,rho,log_err,dfdc,delta_dfdc)

    deallocate(f)

  end subroutine get_df_dcoeff_av_new

end module anharmonic

! This subroutine calculates the L mat needed to get the average of the 
! third order derivatives. It is formed by four polarization vectors 
! times the mass^1/2 divided by the normal length.

subroutine get_odd_straight_with_v4 ( a, wr, er, transmode, amass, ityp_sc, T, v3, v4, phi_sc_odd, &
  n_mode, nat_sc, ntyp)

  implicit none

  double precision, dimension(n_mode), intent(in) :: a, wr
  double precision, dimension(nat_sc,n_mode,3), intent(in) :: er
  logical, dimension(n_mode), intent(in) :: transmode
  double precision, dimension(ntyp), intent(in) :: amass
  integer, dimension(nat_sc), intent(in) :: ityp_sc
  double precision, intent(in) :: T
  double precision, dimension(n_mode,n_mode,n_mode), intent(in) :: v3
  double precision, dimension(n_mode,n_mode,n_mode, n_mode), intent(in) :: v4
  double precision, dimension(n_mode, n_mode), intent(out) :: phi_sc_odd


  integer :: nat_sc, n_mode, nl, ns, ntyp
  double precision, dimension(:,:), allocatable :: l, g, phi_aux, v1, v2, v32, iden
  double precision :: lsum 
  double precision, dimension(:), allocatable :: laux1, lres1, veclong
  double precision, dimension(:), allocatable :: laux2, lres2
 
  double precision, dimension(:,:), allocatable :: lamat, v42, maux
  double precision, dimension(:), allocatable :: work
  integer, dimension(:), allocatable :: ipiv
  integer :: info

  double precision, dimension(:), allocatable :: vv
  double precision, dimension(:), allocatable :: ww
  double precision, dimension(:,:), allocatable :: zz
  double precision, dimension(:,:), allocatable :: cf

  integer :: mu, nu, alpha
  integer :: ka, ja
  integer :: i, j, x, y, z, w

  real :: t1, t2

  logical, parameter :: debug = .true.

  ! Get integers

  if (debug) then
    print *, "=== DEBUG ODD STRAIGHT ==="
    print *, "N_MODE:", n_mode
    print *, "NTYP:", ntyp 
    print *, "NAT_SC:", nat_sc
    call flush()
  end if

  !nat_sc = size(er(:,1,1))
  !n_mode = 3*nat_sc

  ns = n_mode
  nl = n_mode*n_mode

  ! Allocate stuff

  allocate(lamat(nl,nl))
  allocate(v42(nl,nl))
  allocate(maux(nl,nl))
  allocate(ipiv(nl))
  allocate(work(nl))
  allocate(v32(n_mode,n_mode*n_mode))
  allocate(iden(nl,nl))

  allocate(cf(nl,ns))

  allocate(vv(nl*(nl+1)/2))
  allocate(ww(nl))
  allocate(zz(nl,nl))

  ! Get lambda matrix 

  call get_cmat ( a, wr, er, transmode, amass, ityp_sc, T, .true., lamat,n_mode, nat_sc, ntyp )
  
  !print *, "AFTER CMAT"
  !call flush()

  ! Write third and fourth order force constants as rank 2

  ka = 0
   
  do x = 1, n_mode
    do y = 1, n_mode
      ka = ka + 1
      v32(:,ka) = v3(:,x,y)
      ja = 0
      do w = 1, n_mode
        do z = 1, n_mode
          ja = ja + 1
          v42(ja,ka) = v4(w,z,x,y)    
        end do
      end do
    end do
  end do

  ! Prepare identity matrix

  iden = 0.0d0

  do x = 1, nl
    iden(x,x) = 1.0d0
  end do

  ! Calculate ** iden - v4 lamat ** matrix

  !print *, "BEFORE I - V4Lambda"
  !call flush()

  maux = iden

  call dgemm('N','N',nl,nl,nl,-1.0d0,v42,nl,lamat,nl,1.0d0,maux,nl) 

  ! Invert ** iden - lamat v4 **

  !print *, "BEFORE (I - V4Lambda)^-1"
  !call flush()
  

  call dgetrf ( nl, nl, maux, nl, ipiv, info )                                                                                                                                                      
  call dgetri ( nl, maux, nl, ipiv, work, nl, info )   

  ! Take product between lamat and the inverted matrix

  !print *, "BEFORE Lambda(I - V4Lambda)^-1"
  !call flush()
  call dgemm('N','N',nl,nl,nl,1.0d0,lamat,nl,maux,nl,0.0d0,v42,nl)

  ! Calculate final matrix products and assign the correction matrix

  ! Calculate cf = ( 1 - lamat*v4)^-1 lamat *  v3

  !print *, "BEFORE Lambda(I - V4Lambda)^-1 V3"
  !call flush()
  call dgemm('N','T',nl,ns,nl,1.0d0,v42,nl,&
             v32,ns,0.0d0,cf,nl)

  ! Now get:
  ! v3 * ( 1 - lamat*v4)^-1 lamat *  v3

  !print *, "BEFORE V3 Lambda(I - V4Lambda)^-1 V3"
  !call flush()
  call dgemm('N','N',ns,ns,nl,1.0d0,v32,ns,&
             cf,nl,0.0d0,phi_sc_odd,ns)


  !call get_odd_from_cmat_fu2 (v42, v32, phi_sc_odd)

  ! Deallocate stuff

  deallocate(lamat,v32,v42,maux,ipiv,work, cf)

end subroutine get_odd_straight_with_v4 

! This subroutine gets the the C matrix needed for the odd term correction

subroutine get_cmat ( a, wr, er, transmode, amass, ityp_sc, T, v3_log, cmat, &
        n_mode, nat_sc, ntyp )

    implicit none
  
    double precision, dimension(n_mode), intent(in) :: a, wr
    double precision, dimension(nat_sc,n_mode,3), intent(in) :: er
    logical, dimension(n_mode), intent(in) :: transmode
    double precision, dimension(ntyp), intent(in) :: amass
    integer, dimension(nat_sc), intent(in) :: ityp_sc
    double precision, intent(in) :: T
    logical :: v3_log
    double precision, dimension(n_mode*n_mode, n_mode*n_mode), intent(out) :: cmat
  
    integer :: nat_sc, n_mode, n_mode2, ntyp
    double precision, dimension(:,:), allocatable :: e
    double precision, dimension(:,:), allocatable :: mat_w, mat_e, mat_et
  
    integer :: i, mu, nu, alpha
    integer :: ka, ja
    integer :: x, y, z, w
  
    real :: t1, t2

    logical, parameter :: debug = .true.
  
    ! Get integers
    if (debug) then
        print *, "=== DEBUG GET_CMAT ==="
        print *, "N_MODE:", n_mode
        print *, "NAT_SC:", nat_sc 
        print *, "NTYP:", ntyp
        call flush()
    endif
  
    !nat_sc = size(er(:,1,1))
    !n_mode = 3*nat_sc
    n_mode2 = n_mode*n_mode
  
    ! Allocate stuff

    print *, "CMAT: ALLOCATION"
    call flush()
  
  
    allocate(e(n_mode,n_mode))
    allocate (mat_w(n_mode,n_mode))
    allocate (mat_e(n_mode*n_mode,n_mode*n_mode))
    allocate (mat_et(n_mode*n_mode,n_mode*n_mode))

    print *, "CMAT: BEFORE EMAT"
    call flush()
  
    ! Define the polarization vectors as a 3n x 3n matrix (n = nat_sc).
    ! The square root of the mass is also included in the new matrix.
  
    call get_emat ( er, a, amass, ityp_sc, v3_log, transmode, e, n_mode, nat_sc, ntyp)

    print *, "CMAT: after get emat"
    call flush()
  
    ! Calculate the matrix based on the frequencies and lengths
  
    call get_g (a, wr, transmode, T, mat_w, n_mode)

    print *, "CMAT: after get g"
    call flush()
  
    ! We get the e and et matrices
  
    call cpu_time(t1)
  
    ka = 0 ! counter for atom/cartesian index
  
    do x = 1, n_mode
      do y = 1, n_mode
        ka = ka + 1
        ja = 0 ! counter for mode index
        do mu = 1, n_mode 
          do nu = 1, n_mode 
            ja = ja + 1
            mat_e(ka,ja)  = e(nu,x) * e(mu,y)
            mat_et(ja,ka) = mat_e(ka,ja) * mat_w(mu,nu) * 0.5d0
          end do
        end do
      end do
    end do
  
    call cpu_time(t2)
   
    print *, ' Elapsed time calculating mat_e and mat_et = ', t2-t1
  
    ! Perfom matrix product to get c matrix
  
    call cpu_time(t1)
  
    call dgemm('N','N',n_mode2,n_mode2,n_mode2,1.0d0,mat_e,n_mode2,&
               mat_et,n_mode2,0.0d0,cmat,n_mode2)
  
    call cpu_time(t2)
   
    print *, ' Elapsed time calculating cmat = ', t2-t1
    
  !  ! Print c matrix
  !
  !  ka = 0
  !
  !  do x = 1, n_mode
  !    do y = 1, n_mode
  !      ka = ka + 1
  !      ja = 0
  !      do z = 1, n_mode
  !        do w = 1, n_mode
  !          ja = ja + 1
  !          print '(4i4,f24.10)', x, y, z, w,  cmat(ka,ja)  
  !        end do
  !      end do
  !    end do
  !  end do
  
    ! Deallocate objects
  
    deallocate(e)
    deallocate (mat_w)
    deallocate (mat_e)
    deallocate (mat_et)
  
  end subroutine get_cmat

! This subroutine calculates the matrix containing polarization vectors
! masses and the lengths

subroutine get_emat (er, a, amass, ityp_sc, v3_log, transmode, e, n_mode, nat_sc, ntyp)

    implicit none
    
      double precision, dimension(nat_sc,n_mode,3), intent(in) :: er
      double precision, dimension(n_mode), intent(in) :: a
      double precision, dimension(ntyp), intent(in) :: amass
      integer, dimension(nat_sc), intent(in) :: ityp_sc
      logical, intent(in) :: v3_log
      logical, dimension(n_mode), intent(in) :: transmode
      double precision, dimension(n_mode,3*nat_sc), intent(out) :: e
    
      integer :: mu, ka, i, nat_sc, n_mode, alpha, ntyp

      logical, parameter :: debug = .true.
    
      !nat_sc = size(er(:,1,1))
      !n_mode = size(a)

      if (debug) then
        print *, "=== DEBUG GET_EMAT ==="
        print *, "NAT_SC:", nat_sc 
        print *, "N_MODE:", n_mode 
        call flush()
      endif
    
      do mu = 1, n_mode
        ka = 0
        do i = 1, nat_sc
          do alpha = 1, 3
            ka = ka + 1
            if (transmode(mu)) then
              e(mu,ka) = 0.0d0
            else if (v3_log) then
              e(mu,ka) = er(i,mu,alpha) * a(mu) / sqrt(amass(ityp_sc(i)))
            else
              e(mu,ka) = er(i,mu,alpha) * sqrt(amass(ityp_sc(i))) / a(mu)
            end if
          end do
        end do
      end do
    
    end subroutine get_emat
    

!
! Stress tensors are requested and returned in Ha / [x]^3
! where [x]^3 is the unit of measure of the volume variable passed in input
!
!
! Parameters
! ----------
!      volume : double precision
!          The volume of the unit cell
!
subroutine get_stress_tensor(volume, forces_e, u_vector, abinit_stress_tensors, wr, er, T, rho, log_err, &
        stress_tensor, error_on_stress_tensor, nrandom, natoms_sc, nmodes)
  use stochastic
  !use polarization
  
  implicit none
  
  
  double precision, intent(in) :: volume, T
  !type(dynamical_matrix), intent(in) :: dyn
  double precision, dimension(3,3,nrandom), intent(in) :: abinit_stress_tensors
  double precision, dimension(3,3), intent(out) :: stress_tensor
  double precision, dimension(3,3), intent(out) :: error_on_stress_tensor
  double precision, dimension(nmodes), intent(in) :: wr
  double precision, dimension(nrandom), intent(in) :: rho
  double precision, dimension(natoms_sc, nmodes, 3), intent(in) :: er
  double precision, dimension(nrandom,natoms_sc, 3), intent(in) :: forces_e, u_vector
  character (len=10), intent(in) :: log_err
  integer, intent(in) :: nrandom, natoms_sc, nmodes
  

  ! Additional variables
  double precision, dimension(3,3) :: anharmonic_stress, anharmonic_error, harmonic_stress, abinitio_stress, abinitio_error
  double precision, dimension(:,:,:), allocatable :: f_dot_r!, debug_f_dot_r, f_scha, fscha_dot_r
  !double precision, dimension(:,:), allocatable :: f_atom
  !double precision :: volume, scale_factor, iso_pressure, iso_p_err, tmp
  integer :: i, j, k
  logical :: pon

 ! pon = .false.
  
  ! Manage the optional argument print_on_screen
  ! if (present(print_on_screen)) then
  !    pon = print_on_screen
  ! else
  !    pon = .false.
  ! end if

  !scale_factor = opt%celldm(1)

  ! Initialize the f dot r 
  allocate(f_dot_r(3,3,nrandom))
  !allocate(fscha_dot_r(3,3,nrandom))
  !allocate(f_scha(nrandom, natoms_sc, 3))
  !if (opt%debug_stress) allocate(debug_f_dot_r(3,3,nrandom))

  ! If the debugging flag is active, open a file named 'debug_stress_evaluation.dat'
  ! if (opt%debug_stress) then
  !    open (unit = 23, file="debug_stress_evaluation.dat", status="replace")
  !    write (23, *) "# config, 3P abinitio, 3P with ab-forces, 3P harmonic [Ha/bohr^3]"
  ! end if

  ! Compute the average of the force on each atom to suppress the noise
  ! if (opt%stress_suppress_noise) then
  !    allocate(f_atom(opt%natoms_sc, 3))

  !    do i = 1, opt%natoms_sc
  !       do j = 1,3
  !          call average_error_weight(opt%forces(:, i, j), opt%rho, opt%log_err, &
  !               f_atom(i, j), tmp)
  !       end do
  !    end do
  ! end if

  ! Extract the harmonic sscha forces
  ! if (opt%lrigid .and. .not. opt%single_q) then
  !    do k = 1, opt%nrandom
  !       call get_harmonic_force_from_fc(dyn%phi_sc + dyn%phi_sc_nonanal, opt%u_vector(k,:,:), &
  !            f_scha(k,:,:))
  !    end do
  ! else
  !    do k= 1, opt%nrandom
  !       call get_harmonic_force_from_fc(dyn%phi_sc, opt%u_vector(k,:,:), &
  !            f_scha(k,:,:))
  !    end do
  ! end if


  ! Get the scalar product between forces and atomic positions
  do k = 1, nrandom
     do i = 1, 3
        do j = 1, 3
           f_dot_r(i, j, k) = sum(forces_e(k, :, i) * u_vector(k, :, j))
           ! fscha_dot_r(i, j, k) = sum(f_scha(k, :, i) * u_vector(k, :, j))
           ! if (.not. stress_suppress_noise) then 
           !    f_dot_r(i, j, k) = sum(forces_e(k, :, i) * u_vector(k, :, j))
           ! else
           !    f_dot_r(i, j, k) = sum(( forces(k, :, i)) * u_vector(k, :, j))                
           !    ! f_dot_r(i, j, k) = sum(( opt%forces(k, :, i) - f_atom(:, i)) * opt%u_vector(k, :, j))
           ! end if

           ! if (opt%debug_stress) then
           !    debug_f_dot_r(i,j,k) = sum(forces(k, :, i) * u_vector(k, :, j))
           
           ! end if 
        end do
     end do
 
!     
!     print *, ""
!     print *, "CONF", k
!     do i = 1, natoms_sc
!         print "(A8, I8, A10, 3D16.8, A10, 3D16.8)", "AT:", i, "FORCE:", forces_e(k, i,  :), "DISP:", u_vector(k, i, :)
!     end do
!     
!     print *, "F DOT R:"    
!     print "(3D16.8)", f_dot_r(1, :, k)
!     print "(3D16.8)", f_dot_r(2, :, k)
!     print "(3D16.8)", f_dot_r(3, :, k)

     ! If the debugging flag is active, print the trace of the two stress tensors
     ! if (opt%debug_stress) write (23, "(I10, D20.12, D20.12, D20.12)") k, &
     !      abinit_stress_tensors(1, 1, k) + abinit_stress_tensors(2,2,k) + abinit_stress_tensors(3,3,k), &
     !      - (debug_f_dot_r(1,1,k) + debug_f_dot_r(2,2,k) + debug_f_dot_r(3,3,k)) / volume, &
     !      - (fscha_dot_r(1,1,k) +  fscha_dot_r(2,2,k) + fscha_dot_r(3,3,k)) / volume
  end do

  ! Close the debugging file
  !if (opt%debug_stress) close(23)

  ! Average the Ab-Initio stress
  do i = 1, 3
     do j = 1, 3
        ! if (.not. stress_suppress_noise) then
        !    call average_error_weight(abinit_stress_tensors(i, j, :), opt%rho, opt%log_err, &
        !         abinitio_stress(i, j), abinitio_error(i, j))
        !    call average_error_weight(-f_dot_r(i, j, :) / volume, opt%rho, opt%log_err, &
        !         anharmonic_stress(i, j), anharmonic_error(i, j))
        ! else
           call average_error_weight(abinit_stress_tensors(i, j, :) - f_dot_r(i, j, : ) / volume, rho, &
                log_err, stress_tensor(i, j), error_on_stress_tensor(i, j))


           ! Delete the stress tensor
           ! if (opt%is_there_a_stress_matrix_offset) then
           !    stress_tensor(i,j) = stress_tensor(i,j) - opt%stress_offset_matrix(i,j)
        !    end if
        !  end if
     end do
  end do




  ! TODO ---- Implement symmetry operations from quantum espresso to the STRESS TENSOR -------
  ! For now implemented only the fact that the tensor must be symmetric 

  ! If the old formula is used also the harmonic tensor must be computed.
  ! if (.not. stress_suppress_noise) then
  !    do i = 1, 3
  !       do j = i +1, 3
  !          abinitio_stress(i, j) = 0.5d0 * (abinitio_stress(i,j) + abinitio_stress(j, i))
  !          abinitio_stress(j, i) = abinitio_stress(i, j)

  !          abinitio_error(i, j) = 0.5d0 * dsqrt( abinitio_error(i, j)**2 + abinitio_error(j, i)**2)
  !          abinitio_error(j, i) = abinitio_error(i, j)

  !          anharmonic_stress(i, j) = 0.5d0 * (anharmonic_stress(i, j) + anharmonic_stress(j, i))
  !          anharmonic_stress(j, i) = anharmonic_stress(i, j)

  !          anharmonic_error(i, j) = 0.5d0 * dsqrt( anharmonic_error(i, j)**2 + anharmonic_error(j, i)**2)
  !          anharmonic_error(j, i) = anharmonic_error(i, j)
  !       end do
  !    end do

  !    ! ! Add the convergence offset on the abinitio stress tensor diagonal elements
  !    ! do i = 1, 3
  !    !    abinitio_stress(i,i) = abinitio_stress(i,i) + opt%stress_offset
  !    ! end do

  !    ! ! Delete the stress tensor
  !    ! if (opt%is_there_a_stress_matrix_offset) then
  !    !    abinitio_stress(:,:) = abinitio_stress(:,:) - opt%stress_offset_matrix(:,:)
  !    ! end if

  !    ! Get the harmonic pressure
  !    call get_harmonic_stress(volume, wr_sc, er_sc, T, harmonic_stress)

  !    ! Compute the total stress tensor (and its error)
  !    stress_tensor = abinitio_stress - harmonic_stress + anharmonic_stress
  !    error_on_stress_tensor = dsqrt(abinitio_error**2 + anharmonic_error**2)
  ! end if


!
!  if (pon) then
!     ! Compute also the isotropic pressure
!     iso_pressure = 0
!     iso_p_err = 0
!     do i = 1, 3
!        iso_pressure = iso_pressure + stress_tensor(i, i)
!        iso_p_err = iso_p_err + error_on_stress_tensor(i, i)**2       
!     end do
!     iso_pressure = iso_pressure / 3.0d0
!     iso_p_err = dsqrt(iso_p_err) / 3.0d0
!
!     ! Print details on stdout
!     print *, ""
!     print *, "* * * * * * * * * * * * * *"
!     print *, "*                         *"
!     print *, "*          STRESS         *"
!     print *, "*                         *"    
!     print *, "* * * * * * * * * * * * * *"
!     print *, ""
!     print *, "Input unit of measure: Ry/bohr^3 (Pay attention that the input stress matches this unit)"
!
!     ! If all the components of the stress are evaluated, print them in output
!     if (.not. opt%stress_suppress_noise) then
!        print *, "Ab-initio stress:"
!        do i = 1, 3
!           print "(3D18.10)", (abinitio_stress(i, j) * 2.0d0, j = 1, 3)
!        end do
!        print *, "+-"
!        do i = 1, 3
!           print "(3D18.10)", (abinitio_error(i, j) * 2.0d0, j = 1, 3)
!        end do
!        print *, ""
!        print *, "Anharmonic stress:"
!        do i = 1, 3
!           print "(3D18.10)", (anharmonic_stress(i, j) * 2.0d0, j = 1, 3)
!        end do
!        print *, "+-"
!        do i = 1, 3
!           print "(3D18.10)", (anharmonic_error(i, j) * 2.0d0, j = 1, 3)
!        end do
!        print *, ""
!        print *, "Harmonic stress:"
!        do i = 1, 3
!           print "(3D18.10)", (harmonic_stress(i, j) * 2.0d0, j = 1, 3)
!        end do
!        print *, ""
!     end if
!
!     ! Print the total stress
!     print *, "-- TOTAL STRESS [Ry/bohr^3] --"
!     do i = 1, 3
!        print "(3D18.10)", (stress_tensor(i, j) * 2.0d0, j = 1, 3)
!     end do
!     print *, "+-"
!     do i = 1, 3
!        print "(3D18.10)", (error_on_stress_tensor(i, j) * 2.0d0, j = 1, 3)
!     end do
!     print *, ""
!     print *, "-- TOTAL STRESS [GPa] --"
!     do i = 1, 3
!        print "(3D18.10)", (stress_tensor(i, j) * 29421.6144000, j = 1, 3)
!     end do
!     print *, "+-"
!     do i = 1, 3
!        print "(3D18.10)", (error_on_stress_tensor(i, j) * 29421.6144000, j = 1, 3)
!     end do
!     print *, ""
!     print *, "Isotropic pressure (1/3 of the trace) "
!     print "(A10, D18.10, A4,D18.10, A15)", " P = ",  iso_pressure * 2.0d0, " +- ", iso_p_err*2.d0, "[Ry/bohr^3]"
!     print "(A10, D18.10, A4,D18.10, A15)", " P = ",  iso_pressure*29421.6144000, " +- ", &
!          iso_p_err*29421.6144000, "[GPa]"
!
!     print *, ""
!     print *, "* * * * * END STRESS * * * * *"
!     print *, ""
!  end if

  deallocate(f_dot_r)
end subroutine get_stress_tensor

! By LORENZO MONACELLI
!
!
! Get the gradient of the system in the supercell using the Raffaello Bianco's equation
! EQ. A18b of PRB paper (2017) Second order structural....
!
! The equation is modified to exploit the noise reduction as:
!
!
! dF/dPhi = Lambda  Upsilon < u (f - f_scha) > 
!
! The Lambda matrix is the Hessian of the minimization Phi variable (Monacelli et al 2018 PRB)
! Upsilon matrix is the inverse of the covariance matrix Upsilon^{-1}_ab = <u_a u_b>
!
! An optional argumet can be passed, if true the Lambda matrix multiplication is not
! performed. In this way the gradient is automatically preconditioned.
  
subroutine get_gradient_supercell_fast( n_random, natsc, n_modes, ntyp_sc, rho, u_disp, eforces, &
     wr_sc, epols_sc, trans, T, mass, ityp_sc, log_err, grad, grad_err, preconditioned)


  use stochastic
  
  implicit none
  
  integer, intent(in) :: n_random
  ! Number of random configurations
  integer, intent(in) :: natsc
  ! Number of atoms in the supercell
  integer, intent(in) :: n_modes
  ! Number of modes in the supercell (usually 3 * nat_sc)
  integer, intent(in) :: ntyp_sc
  ! Number of different type of atoms in the structure

  double precision, dimension(n_random), intent(in) :: rho
  ! The importance sampling weights of the configurations

  double precision, dimension(n_random, natsc, 3), intent(in) :: u_disp, eforces
  !
  ! The displacement vectors and forces - sscha forces for each configuration.
  ! Displacements are required in bohr, while forces in Ha/bohr
  ! Most importantly, forces and wr unit of measurement must coincide:
  ! If wr is in Ha and u_disp in bohr then forces must be Ha/bohr
  ! if wr is in Ry and u_disp in angstrom then forces must be in Ry/angstrom
  !
  
  double precision, dimension(n_modes), intent(in) :: wr_sc
  double precision, dimension(3 * natsc, n_modes), intent(in) :: epols_sc
  !
  ! Frequencies (in Ha or look above) and polarization vectors for each mode
  ! Polarization vectors are contracted so that the x coord of the i-th atom
  ! of the j-th vector is accessed by epols_sc(x + 3*(i-1), j)
  ! this allows an easy wrapping to the subroutine with python code.
  !
  
  logical, dimension(n_modes), intent(in) :: trans
  ! This is a vector that is True if the mode is a translation, False otherwise
  ! It is needed to generate the Upsilon matrix (as it has a diverging eigenvalue for w->0)

  double precision, intent(in) :: T
  ! Temperature of the system (also this is used to compute the upsilon matrix)

  double precision, dimension(ntyp_sc),  intent(in) :: mass
  ! Mass of the atoms
  ! The unit of measure must be in masses of the electron. (the mass saved in the QE dynamical matrix file
  ! must be multiplied by 2 to match this unit).

  integer, dimension(natsc), intent(in) :: ityp_sc
  ! Type of the atoms in the supercell
  
  character(len=10), intent(in) :: log_err
  ! A flag used to chose the kind of average to be performed 

  double precision, dimension(3*natsc, 3*natsc), intent(out) :: grad, grad_err
  !
  ! The output gradient and its error in real space.
  ! Note that it needs to be symmetrized.
  !
  logical, optional, intent(in) :: preconditioned
  ! If true (default) the gradient is computed without the Lambda matrix mutliplication,
  ! That is as if it was already preconditioned

  
  ! ---------------------------------- END OF INPUT DEFINITION ------------------------------------
  integer i, j, alpha, beta, ical, jcal
  double precision, dimension(3*natsc, 3*natsc) :: uf_mat, err_uf_mat, ups_mat, tmp
  double precision, dimension(3*natsc) :: v_aux1, v_aux2
  double precision, dimension(3*natsc, n_random) :: v_disp, f_aux
  double precision t1, t2
  logical precond
  logical, parameter :: print_input = .false.

  ! Setup the default value of the preconditioned variable
  if (present(preconditioned)) then
     precond = preconditioned
  else
     precond = .true.
  end if

  ! DEBUG INPUT
  if (print_input) then
     print *, "GET_GRADIENT_SUPERCELL INPUT VALUES:"
     print *, "NRAND:", n_random
     print *, "NAT_SC:", natsc
     print *, "N_MODES:", n_modes
     print *, "NTYP_SC:", ntyp_sc
     print *, "RHO:", rho(:)
     print *, "W:", wr_sc(:)
     print *, "TRANS:", trans(:)
     print *, "T:", T
     print *, "MASS:", mass
     print *, "ITYP_SC:", ityp_sc
     print *, "LOG_ERR:", log_err

     print *, ""
     print *, "POL VECTORS:"
     do i = 1, 3*natsc
        print "(A10, I8, A10, 1000E13.4)", "MODE", i, "VECTOR", epols_sc(:, i) 
    end do
    
    print *, ""
    print *, "INPUT U and F"
    do i = 1, n_random
        ! Create the auxiliary vector
        do j = 1, natsc
            do alpha = 1, 3
                v_aux1(alpha + 3* (j-1)) = eforces(i, j, alpha)
                v_aux2(alpha + 3*(j-1)) = u_disp(i, j, alpha)
            end do
        end do
        
        print "(A10, I8, A10, 1000E13.4)", "CONF", i, "FORCE", v_aux1(:)
        print "(A10, I8, A10, 1000E13.4)", "CONF", i, "DISP", v_aux2(:)
    end do
  end if
  
  ! If the gradient is preconditioned then use the 
  ! fast code.
  if (.not. precond) then
      print *, "COMPUTING PRECOND!"
      call flush()
      ! Prepare u and f resizing the arrays
      do i = 1, n_random
          do j= 1, natsc
              do alpha = 1, 3
                  v_disp(alpha + 3*(j-1), i) = u_disp(i, j, alpha)
                  f_aux(alpha + 3*(j-1), i) = eforces(i, j, alpha)
              enddo
          enddo
      enddo
      print *, "CALLING THE FUNCTION"
      call flush()
      call get_unpreconditioned_gradient(v_disp, f_aux, epols_sc, wr_sc, T, mass, ityp_sc, &
              rho, log_err, grad, grad_err, 3*natsc, n_random, n_modes, ntyp_sc)
      print *, "EXITING THE FUNCTION"
      call flush()
      return
  endif
  
  ! Compute the <uf> matrix in the supercell
  uf_mat = 0.0d0
  err_uf_mat = 0.0d0
  
  ! Compute the upsilon matrix in the supercell
  call cpu_time(t1)
  call get_upsilon_matrix(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, mass, ityp_sc, T, ups_mat)
  call cpu_time(t2)
  
  print *, " --> [FORT] Time to compute upsilon:", t2 -t1
  call flush()
  
  call cpu_time(t1)
  do i = 1, n_random
    ! Create the auxiliary vector
    do j = 1, natsc
        do alpha = 1, 3
            !v_aux1(alpha + 3* (j-1)) = eforces(i, j, alpha)
            v_aux2(alpha + 3*(j-1)) = u_disp(i, j, alpha)
        end do
    end do
    
    ! Get the new v_disp 
    ! Take into account the -1 in the gradient equation
    !print *, "BEFORED", i
    call flush()
    call dgemv("N", 3*natsc, 3*natsc, 1.0d0, ups_mat, 3*natsc, v_aux2, 1, 0.0d0, v_disp(:, i), 1)
    !print *, "AFTERD", i
    call flush()
  enddo
  call cpu_time(t2)
  
  print *, " --> [FORT] Time to prepare the <(-Yu)f> computation:", t2 -t1
  call flush()
  
  ! First of all compute Yu for all the vectors

  ! print *, "DISP FORCES:"
  ! do i = 1, size(u_disp(:, 1,1))
  !    print *, "CONFIG", i, "RHO:", rho(i)
  !    do j = 1, natsc
  !       print *, "U:", u_disp(i,j,:), "F:", eforces(i,j,:)
  !    end do
  ! end do
  
  
  call cpu_time(t1)
  do alpha = 1, 3
     do beta = 1, 3
        do i = 1, natsc
           do j = 1, natsc
              ical = alpha + (i-1)*3
              jcal = beta + (j-1)*3
              call average_error_weight(v_disp(ical, :) * eforces(:,  j, beta), &
                   rho, log_err, grad(ical, jcal), grad_err(ical, jcal))
              !print *, "Terra di mezzo:", ical, jcal, "UF:", uf_mat(ical, jcal), &
              !     sum(u_disp(:, i, alpha) * eforces(:, j, beta)) / sum(rho)
           end do
        end do
     end do
  end do

  ! Impose the hermitianity
  ! do ical = 1, 3*natsc
  !    do jcal = ical, 3*natsc
  !       uf_mat(ical, jcal) = 0.5d0 * (uf_mat(ical, jcal) + uf_mat(jcal, ical))
  !       err_uf_mat(ical, jcal) = 0.5d0 *dsqrt(err_uf_mat(ical, jcal)**2 + err_uf_mat(ical, jcal)**2)
  !       if (ical /= jcal) then
  !          uf_mat(jcal, ical) = uf_mat(ical, jcal)
  !          err_uf_mat(jcal, ical) = err_uf_mat(ical, jcal)
  !       end if
  !    end do
  ! end do
  call cpu_time(t2)
  
  print *, " Time to compute <(Yu)f> in real space: ", t2 - t1
  call flush()

  !print *, "Time to compute the upsilon matrix:", t2 - t1

  ! Perform the matrix multiplication
  ! Grad = - Upsilon . <u(f - fscha)>
  ! Note the '-' sign is applied only in the gradient not in the error

  if (print_input) then
     print *, "======== UF MAT ========="
     do ical = 1, 3*natsc
        print "(10000E16.5)", uf_mat(:, ical)
     end do
     
     print *, ""
     print *, "========== UPS MAT ========"
     do ical = 1, 3*natsc
        print "(10000E16.5)", ups_mat(:, ical)
     end do
     print *, ""
  end if
     

  ! Symmetrize the gradient
  ! In fact the product of symmetric matrices is not symmetric!!!!
  do ical = 1, 3*natsc-1
     do jcal = ical + 1, 3*natsc
        grad(ical, jcal) = 0.5d0 * (grad(ical, jcal) + grad(jcal, ical))
        grad(jcal,ical) = grad(ical, jcal)
     end do
  end do

  ! ! Print the gradient
  ! print *, "======= GRADIENT NOW ======="
  ! do ical = 1, 3*natsc
  !    print "(1000E16.5)", grad(:, ical)
  ! end do
  ! call flush()
  
  ! Perform the inverse preconditioning if required:
  if (.not. precond) then
     call cpu_time(t1)
     print *, "Computing the inverse preconditioning..."
     call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
          mass, ityp_sc, T, grad, tmp, .false.)
     ! The lambda matrix is negative defined so multiply it by -1
     grad = -tmp
     !print *, "Setting the error..."
     !call flush()
     call multiply_lambda_tensor(n_modes, natsc, ntyp_sc, wr_sc, epols_sc, trans, &
          mass, ityp_sc, T, grad_err, tmp, .false.)
     grad_err = tmp
     call cpu_time(t2)
     print *, " --> [FORT] Time to compute the inverse preconditioning:", t2 -t1
  end if
  !print *, "Exiting..."
  call flush()
  
end subroutine get_gradient_supercell_fast



!
! Get the standard gradient
! Without doing a computationally expensive 4-rank matrix product calculation
!
! Parameters
! ----------
!  u : displacement for each config (3*natoms vector, n_random)
!  f : forces for each config(f - fscha) (3*natoms vector, n_random)
!  e_pols : polarization vectors : (3*natoms, nmodes)
!  w : frequencies (Ha) : (nmodes)
!  T : temperature (K)
!  gradient : matrix(3*natoms x 3*natoms)
subroutine get_unpreconditioned_gradient(u, f, e_pols, w, T, mass, &
        ityp, rho, log_err, gradient, err_gradient, n, nrand, nmodes, ntyp)  
    use stochastic
  
    implicit none
    integer, intent(in) :: n, nmodes, nrand, ntyp

    double precision, dimension(n, nrand), intent(in) :: u, f
    double precision, dimension(n, nmodes), intent(in) :: e_pols
    double precision, dimension(nmodes), intent(in) :: w
    double precision, intent(in) :: T
    double precision, dimension(ntyp), intent(in) :: mass
    integer, dimension(n/3), intent(in) :: ityp
    double precision, dimension(nrand), intent(in) :: rho
    character(len=10), intent(in) :: log_err
    double precision, dimension(n,n), intent(out) :: gradient, err_gradient
    
    
    ! Now the standard variables
    integer i, mu, nu, alpha, beta
    double precision, dimension(nmodes, nmodes) :: fmunu
    double precision, dimension(nmodes, n) :: fe_aux
    double precision, dimension(nmodes) :: ynu
    double precision, dimension(nmodes, nrand) :: u_new, f_new
    double precision, dimension(nrand) :: av_aux
    
    print *, "IN THE FUNCTION"
    call flush()
    
    ! Get the fmunu matrix and the ynu vector once for all
    do mu = 1, nmodes
        call get_ymu(w(mu), T, ynu(mu))
        do nu = mu, nmodes
            call get_fmunu(w(mu), w(nu), T, fmunu(mu, nu))
            fmunu(mu,nu) = fmunu(mu,nu)
        enddo
    enddo
    
    print *, "GET THE FE"
    call flush()
    
    ! Get feaux
    do alpha = 1, n
        do nu = 1, nmodes
            fe_aux(nu, alpha) = 0.0d0
            
            do mu = 1, nmodes
                fe_aux(nu, alpha) = fe_aux(nu, alpha) + fmunu(nu, mu) * e_pols(alpha, mu)
            enddo
        enddo
    enddo
    print *, "GET THE F and U"
    call flush()
    
    ! Get the displacements and the forces in the polarization vector basis
    do i = 1, nrand
        do nu = 1, nmodes
            u_new(nu, i) = 0.0d0
            f_new(nu, i) = 0.0d0
            do alpha = 1, n
                u_new(nu, i) = u_new(nu, i) + &
                    e_pols(alpha, nu)*u(alpha, i)*dsqrt(mass(ityp(1+(alpha -1)/3)))
                f_new(nu, i) = u_new(nu, i) + &
                    e_pols(alpha, nu)*u(alpha, i)/dsqrt(mass(ityp(1+(alpha -1)/3)))
            enddo
        enddo
    enddo
    
    print *, "START TO GET THE GRADIENT"
    call flush()
    
    ! Get the gradient
    do alpha = 1, n
        do beta = alpha, n
            av_aux(:) = 0.0d0
            do i = 1, nrand
                av_aux(i) = 0.5*sum(fe_aux(:, alpha)*ynu(:)*u_new(:, i)*f_new(:, i)*e_pols(beta,:))
                av_aux(i) = av_aux(i) + &
                    0.5*sum(fe_aux(:, beta)*ynu(:)*u_new(:, i)*f_new(:, i)*e_pols(alpha,:))
            enddo
            
            ! There is a -1 in front of the gradient equation (TO BE ADDED)
            call average_error_weight(av_aux, rho, log_err,&
                gradient(alpha,beta), err_gradient(alpha,beta))
            gradient(beta,alpha) = gradient(alpha,beta)
            err_gradient(beta,alpha) = err_gradient(alpha,beta)
        enddo
    enddo          
       
    print *, "GOT THE GRADIENT"
    call flush()
end subroutine get_unpreconditioned_gradient


subroutine get_ymu(w, T, y_mu) 
  implicit none
  double precision, intent(out) :: y_mu
  double precision, intent(in) :: w, T

  double precision :: n_mu
  double precision, parameter :: epsilon = 1d-6
  double precision, parameter :: K_TO_HA =  6.336857346553283d-06 / 2
  
  ! Get the occupation numbers
  n_mu = 0.0d0
  if (T .gt. epsilon) then
     n_mu = 1 / (dexp(w / (K_to_Ha * T)) - 1)
  end if
  
  if (w .lt. epsilon) then
      y_mu = 0.0d0
  else
      y_mu = 2 * w / (1 + 2 * n_mu)
  endif
end subroutine get_ymu

module thermodynamic

  PUBLIC :: w_to_a
  
  ! The following subroutine translates the frequency in
  ! the a distance
  ! Note w must be in Ha units and T in K, then a is in Bohr.
contains
  subroutine w_to_a(w,T, a, n)
    double precision, intent(in) :: T
    double precision, dimension(n), intent(in) :: w
    double precision, dimension(n), intent(out) :: a
    integer, intent(in) :: n
    
    a = 0.0d0
    if (T .eq. 0.0D0) then
       a(:) = dsqrt(1.0d0 / (2.0d0 * w(:)))
    else
       a(:) = dsqrt((1.0d0 / dtanH(0.5d0 * w * &
            315774.65221921849D0 / T )) / &
            (2.0d0 * w(:)) )
    end if
  end subroutine w_to_a


  ! Computes da/dw starting from the w frequencies
  ! w unit <= Ha
  ! T unit <= K
  ! a unit => Bohr
  subroutine w_to_da(w,T, da, n)
    double precision, intent(in) :: T
    double precision, dimension(n), intent(in) :: w
    double precision, dimension(n), intent(out) :: da
    integer, intent(in) :: n
    double precision, dimension(n) :: a, b
    double precision :: beta


    if (T .eq. 0.0D0) then
       da = - dsqrt(1.0d0 / (8.0d0 *  w**3.0d0))
    else
       !    result_w_to_da = - dsqrt((1.0d0 / dtanH(0.5d0 * w * &
       !                      315774.65221921849D0 / T )) / &
       !                     (8.0d0 * m * w**3.0d0) )     * &
       !                     (1.0d0 +  (w * 315774.65221921849D0 / T) * &
       !                     (1.0d0 / dsinH(0.5d0 * w * &
       !                      315774.65221921849D0 / T )))
       beta =  315774.65221921849D0 / T
       a = w * beta + dsinH(w * beta)
       b = dsqrt(1.0d0 / (32.0d0 *  (w**3.0d0) * &
            (dsinH(0.5d0 * w * beta)**3.0) *  dcosH(0.5d0 * w * beta)))  
       da = - a * b
    end if
  end subroutine w_to_da

  
  ! This function calculates the value of the derivative of the
  ! total free energy of the harmonic oscillator minus the potential
  ! of the harmonic oscillator with respect to the arbitrary frequency:
  !
  ! d [ F_0 - 1/2 m W^2 <u^2>_0 ] / dW   
  ! 
  ! The frequency needs to
  ! be given in Ha, the temperature in K and the mass in Ha atomic
  ! units.
  
  function dW_f0_u0(w,T) result(result_dW_f0_u0)

    double precision, intent(in) :: w, T
    double precision :: result_dW_f0_u0

    if (T .eq. 0.0d0) then
       result_dW_f0_u0 = 0.25d0
    else 
       result_dW_f0_u0 = 0.25d0 * (2.0d0 * nb(w,T) + 1.0d0 +    & 
            2.0d0 * (315774.65221921849D0 / T) * w * &
            dexp(w * 315774.65221921849D0 / T) *      &
            nb(w,T)**2.0d0)
    end if
  end function dW_f0_u0

  
  ! This function calculates the Bose-Einstein distribution function for
  ! temperature T given in K and frequency given in Ha
  function nb(w,T) result(result_nb)
    double precision, intent(in) :: w, T
    double precision :: result_nb
    !  double precision :: T          !MODIFIED
    !  double complex   :: w          !MODIFIED
    !  double complex   :: result_nb  !MODIFIED

    if (T .eq. 0.0D0) then
       result_nb = 0.0D0
    else
       result_nb = 1.0D0 / (dexp(w * 315774.65221921849D0 / T )  - 1.0D0)
    end if

  end function nb

end module thermodynamic

! by LORENZO MONACELLI
! 
!
! This subroutine computes the upsilon matrix
! It is the inverse of the 
!
subroutine get_upsilon_matrix(nmodes, nat, ntyp, wr, epols, trans, mass, ityp, T, ups)
  implicit none
  integer, intent(in) :: nmodes, nat, ntyp
  !
  ! The number of modes
  ! The number of atoms
  ! The number of different types
  !

  double precision, dimension(nmodes), intent(in) :: wr
  !
  ! The frequencies (in Ha) used to compute upsilon matrix
  !

  double precision, dimension(3*nat, nmodes), intent(in) :: epols
  !
  ! Polarization vectors
  !

  logical, dimension(nmodes), intent(in) :: trans
  ! True if the mode is a translation, false otherwise

  double precision, dimension(ntyp), intent(in) :: mass
  ! Mass of each type of atoms in the structure
  
  integer, dimension(nat), intent(in) :: ityp
  ! Type of each atom in the structure
  
  double precision, intent(in) :: T
  ! Temperature in K

  double precision, dimension(3*nat, 3*nat), intent(out) :: ups
  !
  ! The output upsilon matrix in bohr^-2
  !

  ! --------------------------------- END OF INPUT DEFINITION -----------------------------
  double precision, parameter :: K_to_Ha =  6.336857346553283d-06 / 2
  integer :: i, j, k
  double precision :: eigenvalue, nb
  
  ups = 0.0d0
  do i = 1, nmodes
     ! Avoid translational modes
     if (trans(i)) cycle
     !print *, "CYCLE", i
     !print *, "WR", wr(i)
     
     eigenvalue = 2 * wr(i)

     if ( T .gt. 0.01) then
        nb = 1 / (dexp(wr(i) / (T * K_to_Ha)) - 1)
        eigenvalue = eigenvalue / (1 + 2*nb)
     end if
     !print *, "EIGVAL:", eigenvalue

     do j = 1, 3*nat
        do k= 1, 3*nat
           !print *, "= J:",j, "K:", k, "ITYP_INDEX:", 1 + (k-1)/3, "ITYP:", ityp(1 + (k-1)/3)
           !call flush()
           ups(j,k) = ups (j, k) + eigenvalue * epols(j,i) * epols(k,i) * &
               dsqrt(mass(ityp(1+ (j-1) / 3)) * mass(ityp(1 + (k-1)/3)))
        end do
     end do
  end do
end subroutine get_upsilon_matrix

!
! By LORENZO MONACELLI
!
!
! Multiply the given matrix for the Lambda tensor, and overwrite the result

!
! The following matrix get the F_munu defined as
!
! f_munu = - 1/(4w_\mu w_\nu) * 
!    * (2 * n_mu + 1) / (8*w_mu) - dn_dw/4       if w_mu = w_nu
!    * (n_mu + n_nu +1) / (4*(w_mu + w_nu)) - (n_mu - n_nu) / (4*(w_mu - w_nu)) if w_mu != w_nu
! The disequality of w_mu and w_nu is checked with a threshold epsilon defined as a parameter
!
! Note that the Lambda tensor, in this way, is defined as (hbar = 1)
!   Lambda^{abcd} = \sum_{\mu\nu} f_\mu\nu (e_nu^a e_mu^b e_nu^c e_mu^d)/sqrt(Ma Mb Mc Md)
!
subroutine get_fmunu(w_mu, w_nu, T, f_munu) 
  implicit none
  double precision, intent(out) :: f_munu
  double precision, intent(in) :: w_mu, w_nu, T

  double precision :: n_mu, n_nu, dn_dw
  double precision, parameter :: epsilon = 1d-5
  double precision, parameter :: K_TO_HA =  6.336857346553283d-06 / 2
  
  ! Get the occupation numbers
  n_mu = 0.0d0
  n_nu = 0.0d0
  dn_dw = 0.0d0
  if (T /= 0) then
     n_mu = 1 / (dexp(w_mu / (K_to_Ha * T)) - 1)
     n_nu = 1 / (dexp(w_nu / (K_to_Ha * T)) - 1)
     dn_dw = -(K_TO_HA / T) / (2 * dcosh(w_mu * K_TO_HA / T) - 1)
   end if
     
  
  ! If w_mu != w_nu
  if ((abs(w_mu - w_nu) / dsqrt(w_mu* w_nu)) .gt. epsilon) then
     f_munu = (n_mu + n_nu +1) / (4*(w_mu + w_nu)) - (n_mu - n_nu) / (4*(w_mu - w_nu))
  else
     ! Degenerate case
     f_munu = (2 * n_mu + 1) / (8*w_mu) - dn_dw/4
  end if
  f_munu = - f_munu / (w_mu * w_nu)
end subroutine get_fmunu
        
  

subroutine multiply_lambda_tensor(nmodes, nat, ntyp, wr, pols, trans, &
     mass, ityp, T, input_matrix, output_matrix, inverse)
  implicit none
  

  integer, intent(in) :: nmodes, nat, ntyp
  !
  ! The number of modes, atoms and different types in the current structure
  !

  double precision, dimension(nmodes), intent(in) :: wr
  !
  ! Frequencies (in Ha) of the current dynamical matrix
  !

  double precision, dimension(3*nat, nmodes), intent(in) :: pols
  !
  ! Polarization vectors of the current dynamical matrix
  !

  logical, dimension(nmodes), intent(in) :: trans
  !
  ! True if the given mode is a translation, false otherwise
  !

  double precision, dimension(ntyp), intent(in) :: mass
  !
  ! Mass of each atomic type (in bohr^2 / Ha)
  !

  integer, dimension(nat), intent(in) :: ityp
  !
  ! Type of each atom
  !

  double precision, intent(in) :: T
  !
  ! Temperature of the system (in K)
  !

  double precision, dimension(3*nat, 3*nat), intent(in) :: input_matrix
  !
  ! The matrix that must be multiplied by Lambda tensor (and also the result)
  !
  
  double precision, dimension(3*nat, 3*nat), intent(out) :: output_matrix
  !
  ! The result of the multiplication
  !
  logical, intent(in) :: inverse
  !
  ! If true the inverse of Lambda tensor is applied
  
  ! -------------------------------- END OF INPUT DEFINITION ---------------------------------------

  integer :: nu, mu, i, j
  double precision, dimension(3*nat) :: v_aux1
  double precision, dimension(3*nat, nmodes) :: epols_aux ! Polarization vectors renormalized by masses
  double precision :: matrix_munu, fm

  ! Get the polarization vectors renormalized by the masses
  do i = 1, 3*nat
     if (inverse) then
        epols_aux(i, :) = pols(i, :) * dsqrt(mass(ityp( 1+ (i -1)/3)))
     else
        epols_aux(i, :) = pols(i, :) / dsqrt(mass(ityp(1 + (i-1) / 3)))
     end if
  end do
     
  
  
  output_matrix = 0.0d0
  do nu = 1, nmodes
     if (trans(nu)) cycle

     ! Start by computing v_aux1 = matrix |e_nu>
     !print *, "MODE", nu
     !call flush()
     call dgemv("N",  3*nat, 3*nat, 1.0d0, input_matrix, 3*nat, epols_aux(:, nu), 1, 0.0d0, v_aux1, 1)
     do mu = 1, nmodes
        if (trans(mu)) cycle
        ! Compute the matrix element <e_mu | matrix | e_nu>
        matrix_munu =  dot_product(v_aux1, epols_aux(:, mu))
        
        call get_fmunu(wr(mu), wr(nu), T, fm)

        !print *, "WMU:", wr(mu), "WNU:", wr(nu), "FMUNU:", fm, "<emu| M |enu>:", matrix_munu
        !print *, "VAUX:", v_aux1(:)
        !call flush()
        ! Multiply the f_munu
        if (inverse) then
           matrix_munu = matrix_munu / fm
        else
           matrix_munu = matrix_munu * fm
        end if

        
        ! Write the output matrix
        do i = 1, 3*nat
           do j = 1, 3*nat
              output_matrix(i, j) = output_matrix(i, j) + matrix_munu * epols_aux(i, mu) * epols_aux(j, nu)
           end do
        end do
     end do
  end do
end subroutine multiply_lambda_tensor

subroutine cell_force( fcell, ainv, stress, omega, press, wmassIN )
    DOUBLE PRECISION, intent(out) :: fcell(3,3)
    DOUBLE PRECISION, intent(in) :: stress(3,3), ainv(3,3)
    DOUBLE PRECISION, intent(in) :: omega, press
    DOUBLE PRECISION, intent(in), optional :: wmassIN
    integer        :: i, j
    DOUBLE PRECISION :: wmass

    IF (.not. present(wmassIN)) THEN
        wmass = 1.0
    ELSE
        wmass = wmassIN
    END IF

    print *, "omega:", omega
    print *, "press:", press
    print *, "wmass:", wmass
    call flush()

    do j=1,3
        do i=1,3
        fcell(i,j) = ainv(j,1)*stress(i,1) + ainv(j,2)*stress(i,2) + ainv(j,3)*stress(i,3)
        end do
    end do
    do j=1,3
        do i=1,3
        fcell(i,j) = fcell(i,j) - ainv(j,i) * press
        end do
    end do
    fcell = omega * fcell / wmass
    return
end subroutine cell_force

module stochastic

public :: random_gaussian
public :: check_gaussian 
public :: average_1D
public :: average_3D
public :: standard_deviation_1D
public :: get_gaussian_weight
public :: average_error_weight

contains

! This subroutine gives a random gaussian distributed
! number. The distribution is normalized so that
!
! (1 / 2 pi) * Exp [ -y^2 / 2 ]
!
! It has been more or less copied from the book 
! 'Numerical Recipes in C'

! function population_idx(pop_out, pop_in_)
!    implicit none 
!    integer,intent(in) :: pop_out
!    integer,optional :: pop_in_
!    character(len=32) :: population_idx
!    integer :: pop_in
!    character(len=6), EXTERNAL :: int_to_char

!    IF(present(pop_in_))THEN
!      pop_in = pop_in_
!    ELSE
!      pop_in = -1
!    ENDIF

!    IF(pop_in>0)THEN
!     population_idx="_population"//int_to_char(pop_in)
!    ELSE IF(pop_out>0)THEN
!     population_idx="_population"//int_to_char(pop_out)
!    ELSE
!     population_idx=''
!    ENDIF  
!    RETURN
! end function


subroutine random_gaussian(rand)
  double precision, intent(out) :: rand

  double precision :: x1, x2, v1, v2
  double precision :: rsq, fac 

  do

    call random_number(x1)
    call random_number(x2)

    v1 = 2.0d0 * x1 -1.0d0
    v2 = 2.0d0 * x2 -1.0d0

    rsq = v1**2 + v2**2

    if (rsq .le. 1.0d0 .and. rsq .gt. 0.0d0) exit

  end do

  fac = sqrt(-2.0d0 * log(rsq) / rsq)

  rand = v1 * fac

end subroutine random_gaussian

! subroutine random_sobol(method, n, m, rand)
!   USE constants,        ONLY : sqrt2
!   USE SOBOL,            ONLY : i8_sobol
!   implicit none
!   integer,intent(in)  :: n, m ! n configurations, m dimensions
!   real(8),intent(out) :: rand(n,m)
!   character(len=12)   :: method
!   !
!   integer ( kind = 8 ) :: seed, dim_num
!   real(8),allocatable    :: u1(:), u2(:)
!   integer :: i,j
!   !
!   LOGICAL,SAVE :: first = .true.
!   REAL(8),EXTERNAL :: dierfc2
!   !
!   ! just to be sure with integer types:
!   dim_num = m
!   allocate(u1(dim_num),u2(dim_num))
!   !
!   IF(first)THEN
!     if(method(7:7)=='c')then
!       read(method(8:len(method)),*,iostat=i) j
!       if(i/=0) j=0
!       seed = 2**(CEILING( j+ LOG(DBLE(dim_num))/LOG(2.d0)  ))
!     else if(method(7:7)=='p')then
!       read(method(8:len(method)),*,iostat=i) j
!       if(i/=0) j=0
!       seed = 2**j
!     else
!       read(method(7:len(method)),*,iostat=i) j
!       if(i/=0) j=0
!       seed = j
!     endif
!     print*, "Sobol method: "//method, seed
! !     seed = 0
!     first = .false.
!   ELSE
!     print*, "I did not consider the case where Sobol is initialized more than once"
!     stop 1
!   ENDIF
!   !
!   do i = 1,n
!     !
!     call i8_sobol ( dim_num, seed, u1(1:dim_num) )
!     IF(ANY(u1>=1.d0).or.ANY(u1<=-1.d0) ) THEN
!       print*, "WARNING Sobol: a point is on the border"
!     ENDIF
! !     WHERE(u1>=1.d0)  u1 = 1.d0-2**(-dim_num)
! !     WHERE(u1<=-1.d0) u1 = -1.d0+2**(-dim_num)
    
!     u1 = 2*u1-1.d0
! #if defined (__INTEL)
!     ! Next call is inverse Erf, only available in mkl.
!     CALL vderfinv(dim_num, u1, u2)
! #else 
!     ! Or use homebrew inverse erf
!     DO j = 1, dim_num
!       u2(j) = dierfc2(u1(j))
!     ENDDO
! #endif
!     !
!     ! Bad index ordering, but we need it like this:
!     rand(i,:) = -sqrt2 * u2
!   enddo
!   !
!   deallocate(u1,u2)
!   !
! end subroutine random_sobol
! !
! ! This subroutine checks whether the number is a given 
! ! array are formed according to a gaussian distribution.
! ! As an output it gives the file 'test_gaussian' 
! ! where the data is compared to a gaussian distribution.

subroutine check_gaussian(random)

  double precision, dimension(:), intent(in) :: random

  integer :: i1, kg, i2 
  double precision :: pi

  pi = 3.141592653589793238d0

  open (unit=1, file='test_gaussian')

  do i1 = 1, 100
    kg = 0
    do i2 = 1, size(random)
      if (random(i2) .ge. (-5 + (i1-1)*0.1) .and. & 
          random(i2) .lt. (-5 + i1*0.1) ) kg = kg + 1
    end do
    write (unit=1,fmt=*) &
           -5.05d0 + dble(i1)*0.1d0, dble(kg) / dble(size(random)/10), &
            exp(-0.5d0*(-5.05d0 + dble(i1)*0.1d0)**2) / &
            (sqrt(2.0d0 * pi))
  end do

  close (unit=1)

end subroutine check_gaussian

! This subroutine calculates the gaussian weight used for the  
! correlated sampling 

subroutine get_gaussian_weight(q,q_start,a,a_start,rho, n_config, n_modes)

  double precision, dimension(n_config, n_modes), intent(in) :: q_start, q
  double precision, dimension(n_modes), intent(in) :: a_start, a
  double precision, dimension(n_config), intent(out) :: rho
  integer, intent(in) :: n_config, n_modes

  integer :: i, j, N, nmodes

  N = n_config
  nmodes = n_modes

  do i = 1, N
    rho(i) = 1.0d0
    ! Skip the contribution of the acoustic modes
    do j = 1, nmodes
      rho(i) = rho(i) * (a_start(j) / a(j)) * dexp(-(q(i,j)**2)/(2.0d0 * a(j)**2)) / &
             dexp(-(q_start(i,j)**2)/(2.0d0 * a_start(j)**2))
    end do
  end do

end subroutine get_gaussian_weight

! This subroutine calculates the gaussian weight used for the  
! correlated sampling in case there are effective charges

subroutine get_gaussian_weight_eff_charge(q,q_start,a,a_start,mu_relevant,rho)

  double precision, dimension(:,:), intent(in) :: q_start, q
  double precision, dimension(:,:), intent(in) :: a_start, a
  logical, dimension(:), intent(in) :: mu_relevant 
  double precision, dimension(:), intent(out) :: rho

  integer :: i, j, N, nmodes

  N = size(q(:,1))
  nmodes = size(q(1,:))

  do i = 1, N
    rho(i) = 1.0d0
    ! Skip the contribution of the acoustic modes
    do j = 1, nmodes
      if (.not. mu_relevant(j)) cycle
      rho(i) = rho(i) * (a_start(i,j) / a(i,j)) * dexp(-(q(i,j)**2)/(2.0d0 * a(i,j)**2)) / &
             dexp(-(q_start(i,j)**2)/(2.0d0 * a_start(i,j)**2))
    end do
  end do

end subroutine get_gaussian_weight_eff_charge


! This subroutine calculates the average and the error of
! a correlated average of the following type:
!
!     \sum_i f(i) p(i) / \sum_i p(i)
!
! where f(i) is the function to average and p(i) is the 
! weight. The error is calculated using the formula for 
! the propagation of errors.
!

subroutine average_error_weight(f,rho,log_err,av_f,error_f)

  double precision, dimension(:), intent(in) :: f
  double precision, dimension(:), intent(in) :: rho
  character (len=10), intent(in) :: log_err
  double precision, intent(out) :: av_f
  double precision, intent(out) :: error_f

  integer :: nc
  double precision :: av_f1, av_rho, s_f, s_rho, s_f_rho

  double precision,allocatable :: rhof(:)
  logical :: correct_evenodd

  ! Get the number of configurations

  nc = size(f)
  allocate(rhof(nc))

  ! Calculate the auxiliar parameters

  ! profile 5 : avoid multiplying rho times f over and over again
  rhof = rho(:)*f(:)

  av_f1   = sum(rhof(:)) / dble(nc)
  av_rho  = sum(rho(:))  / dble(nc)
  
  s_f     = sum((rhof(:)-av_f1)**2) / dble(nc-1)
  s_rho   = sum((rho(:)-av_rho)**2) / dble(nc-1)
  s_f_rho = sum((rhof(:)-av_f1)*(rho(:)-av_rho)) / dble(nc-1)      

  ! Calculate the average and the error

  if (log_err .eq. 'err_yesrho') then
    av_f    = av_f1 / av_rho
    error_f = (1.0d0/dsqrt(dble(nc))) * abs(av_f1/av_rho)     *  &
              dsqrt( s_f/(av_f1**2) + s_rho/(av_rho**2) - &
                        2*s_f_rho/(av_rho * av_f1) )
  else if (log_err .eq. 'err_nonrho') then
    av_f    = av_f1
    error_f = (1.0d0/dsqrt(dble(nc))) * dsqrt( s_f )
 else
    stop "ERROR; log_err ill defined."
  end if 

  deallocate(rhof)

end subroutine average_error_weight

! This subroutine gives a random number distributed
! on a sphere of radious 1. 
! It has been more or less copied from 
! http://mathworld.wolfram.com/SpherePointPicking.html 

subroutine random_sphere(v_rand)

  double precision, dimension(3), intent(out) :: v_rand

  double precision :: v1, v2, u, theta
  double precision :: twopi

  twopi  = 6.2831853071795862d0 

  call random_number(v1)
  call random_number(v2)

  u     = 2.0 * v1 - 1.0d0
  theta = v2 * twopi
 
  v_rand(1) = dsqrt(1.0 - u**2) * cos(theta)
  v_rand(2) = dsqrt(1.0 - u**2) * sin(theta)
  v_rand(3) = u

end subroutine random_sphere

end module stochastic
